.586
.model flat,stdcall
option casemap :none
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\masm32.inc
include \masm32\include\comdlg32.inc
include \masm32\include\shell32.inc
include \masm32\include\gdi32.inc
include \masm32\include\debug.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\masm32.lib
includelib \masm32\lib\comdlg32.lib
includelib \masm32\lib\shell32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\debug.lib
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
include \masm32\macros\macros.asm
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
S macro	pdata:VARARG 
	LOCAL Buff
.data
	ifidni <pdata>,<>            
		Buff db 0        
	else            
		Buff db pdata,0
	endif
.code
	exitm <OFFSET Buff>
endm
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
.const
	ID_DIR		equ  2000
	ID_MATCH	equ  2001
	ID_LIST		equ  2002
	ID_EDIT		equ  2003
	ID_START	equ  2004
	ID_STOP		equ  2005
	ID_HELP		equ  2006
	ID_ADVANCE	equ  2007
	ID_OPEN		equ  2008
	ID_CLEARF	equ  2009
	ID_CLEARC	equ  2010
	ID_CHK0		equ  2011
	ID_ANIMATE	equ  2012
	ID_TIMER	equ  2013
	ICO_ICON	equ  8000
	
	IDC_CHILD	equ  2998
	IDC_CHK1	equ  2999
	IDC_CHK2	equ  3000
	IDC_CHK3	equ  3001
	IDC_CHK4	equ  3002
	IDC_CHK5	equ  3003
	IDC_CHK6	equ  3004

	IDC_EDT1	equ  3005
	IDC_EDT2	equ  3006
	IDC_EDT3	equ  3007
	IDC_EDT4	equ  3009
	IDC_EDT5	equ  3010
	IDC_EDT6	equ  3011
	IDC_EDT7	equ  3012
	IDC_EDT8	equ  3013
	IDC_EDT9	equ  3014
	IDC_EDT10	equ  3015
	IDC_EDT11	equ  3016
	IDC_EDT12	equ  3017
	IDC_EDT13	equ  3018
	IDC_EDT14	equ  3019

	IDC_OPEN1	equ  3020
	IDC_OPEN2	equ  3021

	IDC_RADIO1	equ  3022
	IDC_RADIO2	equ  3023
	IDC_RADIO3	equ  3024
	IDC_RADIO4	equ  3025
	IDC_RADIO5	equ  3026
	IDC_RADIO6	equ  3027
	IDC_RADIO7	equ  3028
	IDC_RADIO8	equ  3029
	IDC_RADIO9	equ  3030
	IDC_RADIO10	equ  3031
	IDC_RADIO11	equ  3032
	IDC_RADIO12	equ  3033

	IDC_COMBOX	equ  3034

	IDC_DATE1	equ  3035
	IDC_DATE2	equ  3036

	IDC_SPIN1	equ  3037
	IDC_SPIN2	equ  3038
	IDC_SPIN3	equ  3039
	IDC_SPIN4	equ  3040
	IDC_SPIN5	equ  3041
	IDC_SPIN6	equ  3042
	
	IDC_OK		equ  3043
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
.data			
	szPattern	db "All Files (*.*)",0,"*.*",0,0   
	BufAdv1		db 256		dup (0)		
	BufAdv2		db 256		dup (0)		
	BufTest		db 300		dup (0)		
	BufTemp		db 300		dup (0)		
	BufDir		db MAX_PATH	dup (0)		
	BufMatch	db 128		dup (0)		
	BufEdit		db 4096		dup (0)		
	szLenbuf	db 256		dup (0)
	CheckIndexbuf	db 8		dup (0)
	szLineLenArr	dd 10		dup (0)		
	FoundLineIndex	dd 0	
	CheckLineIndex	dd 0	
	hStopEvent	dd 0	
	lineNum		dd 0
	Pattern		dd "*.*",0
	SearchStyle	dd 0
	dDateStyle	dd 3				
	SearchFlag	BOOL TRUE
	NameCaseFlag	BOOL FALSE
	SortN		dd 0
	SortS		dd 0
	SortD		dd 0
	szHelp		\
			db "1.  if you opened the commom dialog to select the start path,",13,10
			db "     put any characters without its childen directory name. that means",13,10
			db "     you'll select the current directory.",13,10
			db "2.  put the '*' in the SearchDir, that means you'll search something",13,10
			db "     in all storage(harddisk,floppydisk,cdrom...)",13,10
			db "3.  if there is nothing in the Match, that means you'll list all files",13,10
			db "     and all directories from the start directory. and so on as include",13,10
			db "     and noninclude in advanced 'Name'",13,10
			db "4.  while the (Start) button changed into (Start(R)) button, you may",13,10
			db "     search again. the (ClearF) button clears the found list. on same",13,10
			db "     time, you can't use search again.",13,10
			db "5.  the 'OK' button means to use the conditon of advanced searchfile;",13,10
			db "     the 'X' Close button means to no use the conditon of advanced searchfile.",13,10
			db "6.  the time of creation(or LastAccess, or LastWrite) is in the date group.",13,10
			db "7.  the selection of ListOpenWith is always valided at any times.",13,10
			db "8.  Click the Topic of list for sort by name or date or time or size.",13,10,0
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
.data?
	hHeap	        HANDLE ?
	ListBuf		dd ?
	hInstance	dd ?
	hDir		HANDLE ?
	hMarch		HANDLE ?
	hList		HANDLE ?
	hEdit		HANDLE ?
	hMain		HANDLE ?
	stCS		CRITICAL_SECTION {?}
	Shellpath	db MAX_PATH	dup (?)		
	CmpPath		db MAX_PATH	dup (?)		
	hBtnOpen	HANDLE ?
	hBtnStop	HANDLE ? 
	hBtnStart	HANDLE ? 
	hBtnClearF	HANDLE ? 
	hBtnClearC	HANDLE ? 
	hBtnHelp 	HANDLE ? 
	hBtnConfig	HANDLE ?
	hListStaic	HANDLE ?
	hEditStaic	HANDLE ?
	hEdit18		HANDLE ?
	
	hwndAnim	HWND	?
	hinstShellLib	HINSTANCE ?

	hEdt1		HANDLE ?
	hEdt2		HANDLE ?
	hEdt3		HANDLE ?
	hEdt4		HANDLE ?
	hEdt5		HANDLE ?
	hEdt6		HANDLE ?
	hEdt7		HANDLE ?
	hEdt8		HANDLE ?
	hEdt9		HANDLE ?
	hEdt10		HANDLE ?
	hEdt11		HANDLE ?
	hEdt12		HANDLE ?
	hEdt13		HANDLE ?
	hEdt14		HANDLE ?

	hOpen1		HANDLE ?
	hOpen2		HANDLE ?
	
	hRADIO1		HANDLE ?
	hRADIO2		HANDLE ?
	hRADIO3		HANDLE ?
	hRADIO4		HANDLE ?
	hRADIO5		HANDLE ?
	hRADIO6		HANDLE ?
	hRADIO7		HANDLE ?
	hRADIO8		HANDLE ?
	hRADIO9		HANDLE ?
	hRADIO10	HANDLE ?
	hRADIO11	HANDLE ?
	hRADIO12	HANDLE ?
	
	hComBox		HANDLE ?
	
	hChk0		HANDLE ?

	hDate1		HANDLE ?
	hDate2		HANDLE ?
	
	hSpin1		HANDLE ?
	hSpin2		HANDLE ?
	hSpin3		HANDLE ?
	hSpin4		HANDLE ?
	hSpin5		HANDLE ?
	hSpin6		HANDLE ?
	
	SearchDirLen	dd ?
	OldWndProc	dd ?
	ListViewStrLen	dd ?
	AgainBuf	dd ?
	pFile		dd ?		; where the zerobyte terminator for path is.
	FileN		db 260 dup (?) 	; the current full path
	DirFlag		BOOL ? 	
	cCmpStyle	dd ?				
	DiskMemAddr	dd ?				
	DiskFileLen	dd ?				
	hFileDisk	HANDLE ?				
	cDateA		SYSTEMTIME {?}				
	cDateB		SYSTEMTIME {?}				
	cTimeA		SYSTEMTIME {?}				
	cTimeB		SYSTEMTIME {?}				
	cSizeA		dd ?				
	cSizeB		dd ?				
	sTempBuf	db 260 dup (?) 	; the current full path
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
.code
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
AddColumnHeader proc @hList:DWORD,nWidth:DWORD,pszName:DWORD
	LOCAL lvcColumn:LV_COLUMN
	LOCAL nCol:DWORD
	
	mov lvcColumn.imask,LVCF_TEXT+LVCF_WIDTH
	mov eax,pszName
	mov lvcColumn.pszText,eax
	mov eax,nWidth
	mov lvcColumn.lx,eax
	
	invoke SendMessage,@hList,LVM_GETHEADER,0,0
	invoke SendMessage,eax,HDM_GETITEMCOUNT,0,0
	mov nCol,eax
	
	invoke SendMessage,@hList,LVM_INSERTCOLUMN,ADDR nCol,ADDR lvcColumn
	ret
AddColumnHeader endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
GetRowCurrentFocus proc iRow:dword
	LOCAL lvi:LV_ITEM
	LOCAL buffer[260]:BYTE

	invoke	RtlZeroMemory,addr buffer,sizeof buffer
	invoke	SendMessage,hList,LVM_GETNEXTITEM,-1,LVNI_FOCUSED
	mov	lvi.iItem,eax
	m2m	lvi.iSubItem,iRow
	mov	lvi.imask,LVIF_TEXT
	lea	eax,buffer					;buffer point
	mov	lvi.pszText,eax
	mov	lvi.cchTextMax,260				; size of buffer
	invoke	SendMessage,hList,LVM_GETITEM,0,addr lvi
	;invoke ustr2dw,addr buffer				; 
	lea	eax,buffer				
	ret

GetRowCurrentFocus endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
AddItem proc iRow:DWORD, iCol:DWORD, tdata:DWORD
	LOCAL newitem:LV_ITEM
	LOCAL lstmsg:DWORD

	mov newitem.imask, LVIF_TEXT
	m2m newitem.iItem, iRow
	m2m newitem.iSubItem, iCol
	m2m newitem.pszText, tdata
	invoke lstrlen, tdata
	inc eax
	mov newitem.cchTextMax, eax
	.IF iCol == 0h
		mov lstmsg, LVM_INSERTITEM
	.ELSE
		mov lstmsg, LVM_SETITEM
	.ENDIF
	invoke SendMessage, hList, lstmsg, 0h, addr newitem
	invoke SendMessage, hList, LVM_ENSUREVISIBLE, iRow, FALSE
	ret
AddItem endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
AddItemInt proc iRow:DWORD, iCol:DWORD, tdword:DWORD
	
	invoke wsprintf, ListBuf, S('%i'), tdword
	invoke AddItem, iRow, iCol, ListBuf
	ret
AddItemInt endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
AddColumn proc tdata:DWORD, cnum:DWORD, wth:DWORD
	LOCAL ncol:LV_COLUMN
	
	m2m ncol.lx, wth
	m2m ncol.pszText, tdata
	invoke lstrlen, tdata
	inc eax
	mov ncol.cchTextMax, eax
	mov ncol.imask, LVCF_TEXT
	.IF ncol.lx != 0h
		or ncol.imask, LVCF_WIDTH
	.ENDIF
	invoke SendMessage, hList, LVM_INSERTCOLUMN, cnum, addr ncol
	ret
AddColumn endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
InitListView proc 
	invoke	SendMessage, hList, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, LVS_EX_FULLROWSELECT;+LVS_EX_GRIDLINES
	invoke	AddColumn, S('Index'), 0d, 45d
	invoke	AddColumn, S('Found'), 1d, 350d
	ret
InitListView endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
CompareSystemTimeD proc aSysTime:SYSTEMTIME,bSysTime:SYSTEMTIME
	Local RetValue:dword

	mov	ax,aSysTime.wYear
	.if	ax > bSysTime.wYear
		mov	RetValue,1
	.elseif	ax == bSysTime.wYear
		mov	ax,aSysTime.wMonth
		.if	ax > bSysTime.wMonth
			mov	RetValue,1
		.elseif ax == bSysTime.wMonth
			mov	ax,aSysTime.wDay
			.if	ax > bSysTime.wDay
				mov	RetValue,1
			.elseif ax == bSysTime.wDay
				mov	RetValue,0
			.else
				mov	RetValue,-1
			.endif
		.else
			mov	RetValue,-1
		.endif
	.else
		mov	RetValue,-1
	.endif
	mov	eax,RetValue
	ret

CompareSystemTimeD endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
CompareSystemTimeT proc aSysTime:SYSTEMTIME,bSysTime:SYSTEMTIME
	Local RetValue:dword

	mov	ax,aSysTime.wHour
	.if	ax > bSysTime.wHour
		mov	RetValue,1
	.elseif	ax == bSysTime.wHour
		mov	ax,aSysTime.wMinute
		.if	ax > bSysTime.wMinute
			mov	RetValue,1
		.elseif ax == bSysTime.wMinute
			mov	ax,aSysTime.wSecond
			.if	ax > bSysTime.wSecond
				mov	RetValue,1
			.elseif ax == bSysTime.wSecond
				mov	RetValue,0
			.else
				mov	RetValue,-1
			.endif
		.else
			mov	RetValue,-1
		.endif
	.else
		mov	RetValue,-1
	.endif
	mov	eax,RetValue
	ret

CompareSystemTimeT endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
GetItemStr proc iRow:DWORD, iCol:DWORD
	LOCAL lvitem:LV_ITEM

	mov lvitem.imask, LVIF_TEXT
	m2m lvitem.iSubItem, iCol
	m2m lvitem.pszText, ListBuf
	mov lvitem.cchTextMax, 512d
	invoke SendMessage, hList, LVM_GETITEMTEXT, iRow, addr lvitem
	.IF eax == 0h
		xor eax, eax
	.ELSE
		mov eax, ListBuf
	.ENDIF
	ret
GetItemStr endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
Add2Check proc uses ebx ecx edx esi edi lpStrCheck:DWORD
	local	szMovLen:dword

	invoke	RtlZeroMemory,addr BufTemp,sizeof BufTemp
	mov	eax,CheckLineIndex
	inc	eax
	invoke	wsprintf,addr BufTemp,S('(%03d) - %s'),eax,lpStrCheck
	invoke	lstrcat,addr BufTemp,S(13,10)
	invoke	lstrcat,addr BufEdit,addr BufTemp
	
	invoke	lstrlen,addr BufEdit
	mov	szMovLen,eax
	invoke	lstrlen,addr BufTemp

	mov	ebx,lineNum
	lea	edi,szLenbuf
	mov	[edi+ebx*4],eax
	
	.if	CheckLineIndex > 6
		mov	ecx,[edi] ;1 line len
		
		lea	edi,BufEdit
		mov	esi,edi
		add	esi,ecx
		sub	szMovLen,ecx
		mov	ecx,szMovLen
		rep	movsb
		mov	ebx,szMovLen
		invoke	RtlZeroMemory,edi,ebx

		mov	ecx,7
		lea	edi,szLenbuf
		mov	esi,edi
		add	esi,4
		rep	movsd	

		dec	lineNum
	.endif
	inc	CheckLineIndex
	inc	lineNum	
	invoke	SetWindowText,hEdit,addr BufEdit
	ret
Add2Check endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
Add2Found proc lpStrFound:DWORD
	local hFile:HANDLE
	local fileinfo:BY_HANDLE_FILE_INFORMATION	
	local FileSize:dword
	Local tTime:SYSTEMTIME
	Local tBuffer[64]:byte
	
	invoke	lstrlen,lpStrFound
	add	ListViewStrLen,eax		;for search again
	
	invoke	EnterCriticalSection,ADDR stCS
	mov	eax,FoundLineIndex
	inc	eax
	invoke	AddItemInt,FoundLineIndex,0d,eax
	invoke	AddItem,FoundLineIndex,1d,lpStrFound
	
	.if	DirFlag==FALSE	;FILE
		
		.if	SearchStyle==4 || SearchStyle==5 || SearchStyle==6
			invoke CreateFile, lpStrFound, GENERIC_READ, FILE_SHARE_READ, NULL,OPEN_EXISTING,\
				FILE_ATTRIBUTE_ARCHIVE, NULL
			.if	eax!=INVALID_HANDLE_VALUE
				mov	hFile,eax
				invoke	GetFileInformationByHandle, hFile, addr fileinfo
				invoke	CloseHandle,hFile
			.endif
		.endif
		.if	SearchStyle==5
			.if	dDateStyle==1
				invoke	RtlZeroMemory, addr tBuffer, sizeof tBuffer
				invoke	RtlZeroMemory, addr tTime, sizeof tTime
				invoke	FileTimeToSystemTime,addr fileinfo.ftCreationTime,addr tTime
				invoke	GetDateFormat, LOCALE_USER_DEFAULT, NULL,addr tTime,S("yyyy-MM-dd"), addr tBuffer, 64
				invoke	AddItem,FoundLineIndex,2d,addr tBuffer
			.elseif	dDateStyle==2
				invoke	RtlZeroMemory, addr tBuffer, sizeof tBuffer
				invoke	RtlZeroMemory, addr tTime, sizeof tTime
				invoke	FileTimeToSystemTime,addr fileinfo.ftLastAccessTime,addr tTime
				invoke	GetDateFormat, LOCALE_USER_DEFAULT, NULL,addr tTime,S("yyyy-MM-dd"), addr tBuffer, 64
				invoke	AddItem,FoundLineIndex,2d,addr tBuffer
			.elseif	dDateStyle==3
				invoke	RtlZeroMemory, addr tBuffer, sizeof tBuffer
				invoke	RtlZeroMemory, addr tTime, sizeof tTime
				invoke	FileTimeToSystemTime,addr fileinfo.ftLastWriteTime,addr tTime
				invoke	GetDateFormat, LOCALE_USER_DEFAULT, NULL,addr tTime,S("yyyy-MM-dd"), addr tBuffer, 64
				invoke	AddItem,FoundLineIndex,2d,addr tBuffer
			.endif
		.elseif	SearchStyle==6
			.if	dDateStyle==1
				invoke	RtlZeroMemory, addr tBuffer, sizeof tBuffer
				invoke	RtlZeroMemory, addr tTime, sizeof tTime
				invoke	FileTimeToSystemTime,addr fileinfo.ftCreationTime,addr tTime
				invoke	GetTimeFormat, LOCALE_USER_DEFAULT,NULL,addr tTime, S("   HH:mm:ss"), addr tBuffer, 64
				invoke	AddItem,FoundLineIndex,2d,addr tBuffer
			.elseif	dDateStyle==2
				invoke	RtlZeroMemory, addr tBuffer, sizeof tBuffer
				invoke	RtlZeroMemory, addr tTime, sizeof tTime
				invoke	FileTimeToSystemTime,addr fileinfo.ftLastAccessTime,addr tTime
				invoke	GetTimeFormat, LOCALE_USER_DEFAULT,NULL,addr tTime, S("   HH:mm:ss"), addr tBuffer, 64
				invoke	AddItem,FoundLineIndex,2d,addr tBuffer
			.elseif	dDateStyle==3
				invoke	RtlZeroMemory, addr tBuffer, sizeof tBuffer
				invoke	RtlZeroMemory, addr tTime, sizeof tTime
				invoke	FileTimeToSystemTime,addr fileinfo.ftLastWriteTime,addr tTime
				invoke	GetTimeFormat, LOCALE_USER_DEFAULT,NULL,addr tTime, S("   HH:mm:ss"), addr tBuffer, 64
				invoke	AddItem,FoundLineIndex,2d,addr tBuffer
			.endif
		.elseif	SearchStyle==4
			invoke	AddItemInt,FoundLineIndex,2d,fileinfo.nFileSizeLow
		.endif
	.else
		invoke	AddItem,FoundLineIndex,2d,S("-")
	.endif
	inc	FoundLineIndex
	
	invoke	LeaveCriticalSection,ADDR stCS
	
	ret
Add2Found endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
IncludeCompareByte proc uses ebx ecx edx esi edi lpTarget:DWORD,TargetLen:DWORD,lpFound:DWORD,FoundLen:DWORD

	mov	ebx,TargetLen
	.if	ebx >= FoundLen
		mov	esi,lpTarget
		xor	ecx,ecx		
		.repeat	
			mov	edi,lpFound
			xor	edx,edx
			.repeat	
				mov	al,BYTE PTR [edi+edx]
				cmp	al,BYTE PTR [esi+edx]
				jnz	@F
				inc	edx
			.until	edx==FoundLen
			jmp	@Include
@@:
			inc	esi
			inc	ecx
		.until	ecx==TargetLen
	.endif
	mov	eax,0
	ret
@Include:	
	mov	eax,1
	ret

IncludeCompareByte endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
DoneMatch proc lpStrTarget:DWORD,lpStrFound:DWORD
	local	SizeT,SizeF,szLowerT,szLowerF
	
	invoke	lstrlen,lpStrTarget
	mov	SizeT,eax

	invoke	lstrlen,lpStrFound
	mov	SizeF,eax
	
	invoke	IsDlgButtonChecked, hMain, ID_CHK0  
	.if	eax == BST_CHECKED
		m2m	szLowerT,lpStrTarget
		m2m	szLowerF,lpStrFound
	.else
		invoke	szLower,lpStrTarget 
		mov	szLowerT,eax
	
		invoke	szLower,lpStrFound
		mov	szLowerF,eax
	.endif
	invoke	IncludeCompareByte,szLowerT,SizeT,szLowerF,SizeF 
	
	ret
DoneMatch endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
DoneName proc uses ebx lpStrTarget:DWORD,lpStrInclude:DWORD,lpStrOutside:DWORD
	local	SizeT,SizeF,SizeO,szLowerT,szLowerF,szLowerO
	local	RetValue:dword

	invoke	lstrlen,lpStrTarget
	mov	SizeT,eax

	invoke	lstrlen,lpStrInclude
	mov	SizeF,eax
	
	invoke	lstrlen,lpStrOutside
	mov	SizeO,eax
	
	invoke	IsDlgButtonChecked, hMain, ID_CHK0  
	.if	eax == BST_CHECKED
		m2m	szLowerT,lpStrTarget
		m2m	szLowerF,lpStrInclude
		m2m	szLowerO,lpStrOutside
	.else
		invoke	szLower,lpStrTarget 
		mov	szLowerT,eax
	
		invoke	szLower,lpStrInclude
		mov	szLowerF,eax
		
		invoke	szLower,lpStrOutside
		mov	szLowerO,eax
	.endif
	invoke	IncludeCompareByte,szLowerT,SizeT,szLowerF,SizeF
	mov	RetValue,eax
	invoke	IncludeCompareByte,szLowerT,SizeT,szLowerO,SizeO
	.if	eax==0
		mov	ebx,1
	.elseif	eax==1
		mov	ebx,0
	.endif
	
	and	ebx,RetValue
	mov	eax,ebx
	ret

DoneName endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
DoneContent proc lpStrTarget:DWORD,lpStrInclude:DWORD,lpStrOutside:DWORD
	local SizeT,SizeF,SizeO
	local hFile:HANDLE
	local hMapFile:HANDLE
	local pMemory:DWORD
	local RetValue:dword
	
	.if	DirFlag==FALSE
		invoke CreateFile, lpStrTarget, GENERIC_READ, FILE_SHARE_READ, NULL,OPEN_EXISTING,\
			FILE_ATTRIBUTE_ARCHIVE, NULL
		.if	eax!=INVALID_HANDLE_VALUE
			mov	hFile,eax
			invoke	CreateFileMapping, hFile, NULL, PAGE_READONLY, 0, 0, NULL
			mov	hMapFile, eax
			invoke	MapViewOfFile, hMapFile, FILE_MAP_READ, 0, 0, 0
			mov	pMemory, eax

			invoke	GetFileSize, hFile, NULL
			mov	SizeT,eax

			invoke	lstrlen,lpStrInclude
			mov	SizeF,eax
	
			invoke	lstrlen,lpStrOutside
			mov	SizeO,eax
	
			invoke	IncludeCompareByte,pMemory,SizeT,lpStrInclude,SizeF
			mov	RetValue,eax
			
			invoke	IncludeCompareByte,pMemory,SizeT,lpStrOutside,SizeO
			.if	eax==0
				mov	ebx,1
			.elseif	eax==1
				mov	ebx,0
			.endif
			
			and	ebx,RetValue
			mov	RetValue,ebx
			
			invoke	UnmapViewOfFile,pMemory
			invoke	CloseHandle,hMapFile
			invoke	CloseHandle,hFile 
		.else
			mov	RetValue,0
		.endif
		mov	eax,RetValue
	.else
		mov	eax,0	;directory
	.endif
	ret
DoneContent endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
DoneDisk proc uses ebx ecx edx esi edi lpStrTarget:DWORD,lpFileMemAddr:DWORD,SizeF:DWORD
	local SizeT:DWORD
	local hFile:HANDLE
	local hMapFile:HANDLE
	local pMemory:DWORD
	local RetValue:dword
	
	.if	DirFlag==FALSE
		invoke CreateFile, lpStrTarget, GENERIC_READ, FILE_SHARE_READ, NULL,OPEN_EXISTING,\
			FILE_ATTRIBUTE_ARCHIVE, NULL
		.if	eax!=INVALID_HANDLE_VALUE
			mov	hFile,eax
			invoke	CreateFileMapping, hFile, NULL, PAGE_READONLY, 0, 0, NULL
			mov	hMapFile, eax
			invoke	MapViewOfFile, hMapFile, FILE_MAP_READ, 0, 0, 0
			mov	pMemory, eax

			invoke	GetFileSize, hFile, NULL
			mov	SizeT,eax
			
			invoke	IncludeCompareByte,pMemory,SizeT,lpFileMemAddr,SizeF
			mov	RetValue,eax
	
			invoke	UnmapViewOfFile,pMemory
			invoke	CloseHandle,hMapFile
			invoke	CloseHandle,hFile 
		.else
			mov	RetValue,0
		.endif 
		mov	eax,RetValue
	.else
		mov	eax,0
	.endif
	ret
DoneDisk endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
DoneDate proc uses ebx ecx edx esi edi lpFile:DWORD,aDateA:SYSTEMTIME,aDateB:SYSTEMTIME,DateStyle:DWORD,CmpStyle:DWORD
	local hFile:HANDLE
	local fileinfo:BY_HANDLE_FILE_INFORMATION	
	Local tTime:SYSTEMTIME
	Local RetValue:dword
	
	.if	DirFlag==FALSE
		invoke CreateFile, lpFile, GENERIC_READ, FILE_SHARE_READ, NULL,OPEN_EXISTING,\
			FILE_ATTRIBUTE_ARCHIVE, NULL
		.if	eax!=INVALID_HANDLE_VALUE
			mov	hFile,eax
			invoke	GetFileInformationByHandle, hFile, addr fileinfo
			invoke	CloseHandle,hFile

			invoke	RtlZeroMemory, addr tTime, sizeof tTime
			.if	dDateStyle==1	;create
				invoke	FileTimeToSystemTime,addr fileinfo.ftCreationTime,addr tTime
				.if	CmpStyle==0	;x>a
					invoke	CompareSystemTimeD,tTime,aDateA
					.if	eax==1
						mov	RetValue,1
					.else
						mov	RetValue,0
					.endif
				.elseif	CmpStyle==1	;b>= x >=a
					invoke	CompareSystemTimeD,tTime,aDateA
					.if	eax==1 || eax==0
						mov	RetValue,1
					.else
						mov	RetValue,0
					.endif
					invoke	CompareSystemTimeD,tTime,aDateB
					.if	eax==-1 || eax==0
						mov	eax,1
					.else
						mov	eax,0
					.endif
					and	eax,RetValue
					mov	RetValue,eax
				.elseif	CmpStyle==2	;x<a
					invoke	CompareSystemTimeD,tTime,aDateA
					.if	eax==-1
						mov	RetValue,1
					.else
						mov	RetValue,0
					.endif
				.endif
			.elseif	dDateStyle==2	;LastAccess
				invoke	FileTimeToSystemTime,addr fileinfo.ftLastAccessTime,addr tTime
				.if	CmpStyle==0	;x>a
					invoke	CompareSystemTimeD,tTime,aDateA
					.if	eax==1
						mov	RetValue,1
					.else
						mov	RetValue,0
					.endif
				.elseif	CmpStyle==1	;b>= x >=a
					invoke	CompareSystemTimeD,tTime,aDateA
					.if	eax==1 || eax==0
						mov	RetValue,1
					.else
						mov	RetValue,0
					.endif
					invoke	CompareSystemTimeD,tTime,aDateB
					.if	eax==-1 || eax==0
						mov	eax,1
					.else
						mov	eax,0
					.endif
					and	eax,RetValue
					mov	RetValue,eax
				.elseif	CmpStyle==2	;x<a
					invoke	CompareSystemTimeD,tTime,aDateA
					.if	eax==-1
						mov	RetValue,1
					.else
						mov	RetValue,0
					.endif
				.endif
			.elseif	dDateStyle==3	;LastWrite
				invoke	FileTimeToSystemTime,addr fileinfo.ftLastWriteTime,addr tTime
				.if	CmpStyle==0	;x>a
					invoke	CompareSystemTimeD,tTime,aDateA
					.if	eax==1
						mov	RetValue,1
					.else
						mov	RetValue,0
					.endif
				.elseif	CmpStyle==1	;b>= x >=a
					invoke	CompareSystemTimeD,tTime,aDateA
					.if	eax==1 || eax==0
						mov	RetValue,1
					.else
						mov	RetValue,0
					.endif
					invoke	CompareSystemTimeD,tTime,aDateB
					.if	eax==-1 || eax==0
						mov	eax,1
					.else
						mov	eax,0
					.endif
					and	eax,RetValue
					mov	RetValue,eax
				.elseif	CmpStyle==2	;x<a
					invoke	CompareSystemTimeD,tTime,aDateA
					.if	eax==-1
						mov	RetValue,1
					.else
						mov	RetValue,0
					.endif
				.endif
			.endif
		.else
			mov	RetValue,0
		.endif
		mov	eax,RetValue
	.else
		mov	eax,0
	.endif
	ret
DoneDate endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
DoneTime proc uses ebx ecx edx esi edi lpFile:DWORD,aTimeA:SYSTEMTIME,aTimeB:SYSTEMTIME,TimeStyle:DWORD,CmpStyle:DWORD
	local hFile:HANDLE
	local fileinfo:BY_HANDLE_FILE_INFORMATION	
	Local tTime:SYSTEMTIME
	Local RetValue:dword
	
	.if	DirFlag==FALSE
		invoke CreateFile, lpFile, GENERIC_READ, FILE_SHARE_READ, NULL,OPEN_EXISTING,\
			FILE_ATTRIBUTE_ARCHIVE, NULL
		.if	eax!=INVALID_HANDLE_VALUE
			mov	hFile,eax
			invoke	GetFileInformationByHandle, hFile, addr fileinfo
			invoke	CloseHandle,hFile

			invoke	RtlZeroMemory, addr tTime, sizeof tTime
			.if	dDateStyle==1	;create
				invoke	FileTimeToSystemTime,addr fileinfo.ftCreationTime,addr tTime
				.if	CmpStyle==0	;x>a
					invoke	CompareSystemTimeT,tTime,aTimeA
					.if	eax==1
						mov	RetValue,1
					.else
						mov	RetValue,0
					.endif
				.elseif	CmpStyle==1	;b>= x >=a
					invoke	CompareSystemTimeT,tTime,aTimeA
					.if	eax==1 || eax==0
						mov	RetValue,1
					.else
						mov	RetValue,0
					.endif
					invoke	CompareSystemTimeT,tTime,aTimeB
					.if	eax==-1 || eax==0
						mov	eax,1
					.else
						mov	eax,0
					.endif
					and	eax,RetValue
					mov	RetValue,eax
				.elseif	CmpStyle==2	;x<a
					invoke	CompareSystemTimeT,tTime,aTimeA
					.if	eax==-1
						mov	RetValue,1
					.else
						mov	RetValue,0
					.endif
				.endif
			.elseif	dDateStyle==2	;LastAccess
				invoke	FileTimeToSystemTime,addr fileinfo.ftLastAccessTime,addr tTime
				.if	CmpStyle==0	;x>a
					invoke	CompareSystemTimeT,tTime,aTimeA
					.if	eax==1
						mov	RetValue,1
					.else
						mov	RetValue,0
					.endif
				.elseif	CmpStyle==1	;b>= x >=a
					invoke	CompareSystemTimeT,tTime,aTimeA
					.if	eax==1 || eax==0
						mov	RetValue,1
					.else
						mov	RetValue,0
					.endif
					invoke	CompareSystemTimeT,tTime,aTimeB
					.if	eax==-1 || eax==0
						mov	eax,1
					.else
						mov	eax,0
					.endif
					and	eax,RetValue
					mov	RetValue,eax
				.elseif	CmpStyle==2	;x<a
					invoke	CompareSystemTimeT,tTime,aTimeA
					.if	eax==-1
						mov	RetValue,1
					.else
						mov	RetValue,0
					.endif
				.endif
			.elseif	dDateStyle==3	;LastWrite
				invoke	FileTimeToSystemTime,addr fileinfo.ftLastWriteTime,addr tTime
				.if	CmpStyle==0	;x>a
					invoke	CompareSystemTimeT,tTime,aTimeA
					.if	eax==1
						mov	RetValue,1
					.else
						mov	RetValue,0
					.endif
				.elseif	CmpStyle==1	;b>= x >=a
					invoke	CompareSystemTimeT,tTime,aTimeA
					.if	eax==1 || eax==0
						mov	RetValue,1
					.else
						mov	RetValue,0
					.endif
					invoke	CompareSystemTimeT,tTime,aTimeB
					.if	eax==-1 || eax==0
						mov	eax,1
					.else
						mov	eax,0
					.endif
					and	eax,RetValue
					mov	RetValue,eax
				.elseif	CmpStyle==2	;x<a
					invoke	CompareSystemTimeT,tTime,aTimeA
					.if	eax==-1
						mov	RetValue,1
					.else
						mov	RetValue,0
					.endif
				.endif
			.endif
		.else
			mov	RetValue,0
		.endif
		mov	eax,RetValue
	.else
		mov	eax,0
	.endif
 	
	ret
DoneTime endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
DoneSize proc uses ebx ecx edx esi edi lpFile:DWORD,aSizeA:DWORD,aSizeB:DWORD,CmpStyle:DWORD
	local hFile:HANDLE
	local fileinfo:BY_HANDLE_FILE_INFORMATION	
	Local RetValue:dword
	
	.if	DirFlag==FALSE
		invoke CreateFile, lpFile, GENERIC_READ, FILE_SHARE_READ, NULL,OPEN_EXISTING,\
			FILE_ATTRIBUTE_ARCHIVE, NULL
		.if	eax!=INVALID_HANDLE_VALUE
			mov	hFile,eax
			invoke	GetFileInformationByHandle, hFile, addr fileinfo
			invoke	CloseHandle,hFile

			mov	eax,fileinfo.nFileSizeLow
			.if	CmpStyle==0	;x>a
				.if	eax > aSizeA
					mov	RetValue,1
				.else
					mov	RetValue,0
				.endif
			.elseif	CmpStyle==1	;b>= x >=a
				.if	eax >= aSizeA && eax<=aSizeB
					mov	RetValue,1
				.else
					mov	RetValue,0
				.endif
			.elseif	CmpStyle==2	;x<a
				.if	eax < aSizeA
					mov	RetValue,1
				.else
					mov	RetValue,0
				.endif
			.endif
		.else
			mov	RetValue,0
		.endif
		mov	eax,RetValue
	.else
		mov	eax,0
	.endif
 	
	ret
DoneSize endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
SearchForFile proc uses edx ecx StartPath:DWORD
; assumes FileN contains full path to folder wanted,pFile points to zero byte terminator
	LOCAL SearchHandle :dword
	LOCAL LastFilePtr :dword
	LOCAL FindData:WIN32_FIND_DATA	
	
	mov	eax,pFile
	.if	byte ptr [eax-1]!='\'		;; add trailing slash if needed
		mov	word ptr [eax],005Ch	;"5c='\'"; backslash plus zero byte terminator
		inc	eax
		inc	pFile
	.endif
	mov	LastFilePtr,eax			; save pointer to end of string
	mov	ecx,Pattern
	mov	[eax],ecx			; set "*.*" search pattern, including zero byte terminator
	invoke	FindFirstFile,StartPath,ADDR FindData
	.if	eax!=INVALID_HANDLE_VALUE
		mov	SearchHandle,eax
		
		mov	eax,LastFilePtr
		mov	[eax],byte ptr 0		; restore string terminator to print file names
@1:
		lea	edx,FindData.cFileName
		.if	byte ptr [edx]!='.'		; discard current and parent directory
			mov	ecx,LastFilePtr		; still have address of wfd.cFileName in edx
@@:
			mov	al,byte ptr [edx]	; tack new file or folder name onto current folder
			mov	byte ptr [ecx],al
			inc	edx
			inc	ecx
			or 	al,al
			jnz	@b
			dec	ecx
			mov	pFile,ecx		; save new pointer in case of folder
			
			mov	ebx,FindData.dwFileAttributes
			and	ebx,FILE_ATTRIBUTE_DIRECTORY
			.if	ebx	; folder
				mov	DirFlag,TRUE
				.if	SearchStyle==0
					invoke	DoneMatch,addr FindData.cFileName,addr BufMatch
					.if	eax==1
						invoke	Add2Found,StartPath
					.endif
				.elseif SearchStyle==1		;Name	
					invoke	DoneName,addr FindData.cFileName,offset BufAdv1,offset BufAdv2
					.if	eax==1
						invoke	Add2Found,StartPath
					.endif
				.endif
				invoke	Add2Check,StartPath
				invoke	SearchForFile,StartPath
				
			.else	;filename
				mov	DirFlag,FALSE
				.if	SearchStyle==0		;match
					invoke	DoneMatch,addr FindData.cFileName,addr BufMatch
					.if	eax==1
						invoke	Add2Found,StartPath
					.endif
				.elseif SearchStyle==1		;Name	
					invoke	DoneName,addr FindData.cFileName,addr BufAdv1,addr BufAdv2
					.if	eax==1
						invoke	Add2Found,StartPath
					.endif
				.elseif SearchStyle==2		;Content	
					invoke	DoneContent,StartPath,addr BufAdv1,addr BufAdv2
					.if	eax==1
						invoke	Add2Found,StartPath
					.endif
				.elseif SearchStyle==3		;Content(disk)	
					invoke	DoneDisk,StartPath,DiskMemAddr,DiskFileLen
					.if	eax==1
						invoke	Add2Found,StartPath
					.endif
				.elseif SearchStyle==4		;Size	
					invoke	DoneSize,StartPath,cSizeA,cSizeB,cCmpStyle
					.if	eax==1
						invoke	Add2Found,StartPath
					.endif
				.elseif SearchStyle==5		;Date	
					invoke	DoneDate,StartPath,cDateA,cDateB,dDateStyle,cCmpStyle
					.if	eax==1
						invoke	Add2Found,StartPath
					.endif
				.elseif SearchStyle==6		;Time	
					invoke	DoneTime,StartPath,cTimeA,cTimeB,dDateStyle,cCmpStyle
					.if	eax==1
						invoke	Add2Found,StartPath
					.endif
				.endif
				invoke	Add2Check,StartPath
			.endif
		.endif
	
		invoke	WaitForSingleObject,hStopEvent,INFINITE
		invoke	FindNextFile, SearchHandle,ADDR FindData
		.if	eax!=0
			jmp	@1
		.endif
		invoke	FindClose,SearchHandle	; done with this search handle, close it

	.endif
	mov	eax,LastFilePtr			; restore back to where we started
	mov	pFile,eax
	mov	[eax],byte ptr 0		; restore string terminator
	ret

SearchForFile endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
GetPathAndNameFromDLG proc uses ebx hWin:HANDLE,PathBuf:Dword
	local ofn:OPENFILENAME

	invoke	RtlZeroMemory, addr ofn, sizeof ofn
	invoke	RtlZeroMemory, addr Shellpath, sizeof Shellpath
	
	mov	ofn.lStructSize,4Ch
        invoke	GetVersion
        .if  eax > 0
		add ofn.lStructSize,0Ch
	.endif
	m2m	ofn.hwndOwner,	hWin 
	m2m	ofn.lpstrFilter,offset szPattern  
	mov	ofn.nMaxFile,	260
	m2m	ofn.lpstrTitle,	S('SearchFile__GetPathName')
        m2m	ofn.hInstance,	hInstance
	mov	ebx,PathBuf
	mov	ofn.lpstrFile,ebx

	invoke	GetOpenFileName,addr ofn

	ret
GetPathAndNameFromDLG endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
GetPathFromDLG proc uses ecx edx hWin:HANDLE
	local FileName[MAX_PATH]:BYTE
	local ofn:OPENFILENAME

	invoke	RtlZeroMemory, addr ofn, sizeof ofn
	invoke	RtlZeroMemory, addr FileName, sizeof FileName
	
	mov	ofn.lStructSize,4Ch
        invoke	GetVersion
        .if  eax > 0
		add ofn.lStructSize,0Ch
	.endif
	m2m	ofn.hwndOwner,	hWin 
	m2m	ofn.lpstrFilter,offset szPattern  
	mov	ofn.nMaxFile,	260
	m2m	ofn.lpstrTitle,	S('SearchFile__GetStartPath')
        m2m	ofn.hInstance,	hInstance
	lea	ecx,FileName
	mov	ofn.lpstrFile,ecx

	invoke	GetOpenFileName,addr ofn
	
	lea	edx,FileName
	invoke	lstrlen ,edx
	mov	ecx,eax
	add	edx,ecx
@@:
	.if	ecx != 0
		.if byte ptr [edx]=="\"	
			mov	byte ptr [edx+1],0
			lea 	eax,FileName		
			jmp	@Exit
		.endif
		dec	edx
		dec	ecx
		jmp	@B
	.else
		invoke	MessageBox,0,0,0,0
		mov	eax,0
	.endif
@Exit:	
	ret
GetPathFromDLG endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
szCopy proc uses esi edi szDest:DWORD,szSource:DWORD
    
	mov	esi,szSource
	cld                             ; copy forwards
	mov	edi,szDest
@@:
	.if	byte ptr [esi+03]==00        ; better branching
		movsd
		ret
	.elseif	byte ptr [esi+02]==00
		movsw
		ret
	.elseif	byte ptr [esi+01]==00
		movsw
		ret
	.elseif	byte ptr [esi+00]==00
		movsb
		ret
	.endif
	movsd                           ; else move DW ESI --> EDI & increment
	jmp	@B

szCopy endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
cStaticLtext proc hParent:DWORD, lpText:DWORD,x:DWORD,y:DWORD,w:DWORD,h:DWORD,ID:DWORD
	LOCAL hFont :DWORD

	invoke	GetStockObject,ANSI_VAR_FONT
	mov	hFont, eax

	invoke	CreateWindowEx,0,S('STATIC'),lpText,WS_CHILD or WS_VISIBLE or SS_LEFT,
			x,y,w,h,hParent,ID,hInstance,NULL
	invoke	SendMessage,eax,WM_SETFONT,hFont, 0
	ret

cStaticLtext endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
cGroupButton proc hParent:DWORD, lpText:DWORD,x:DWORD,y:DWORD,w:DWORD,h:DWORD,ID:DWORD
	LOCAL hFont :DWORD

	invoke	GetStockObject,ANSI_VAR_FONT
	mov	hFont, eax

	invoke	CreateWindowEx,0,S('BUTTON'),lpText,050000007H + BS_FLAT,
			x,y,w,h,hParent,ID,hInstance,NULL
	push	eax
	invoke	SendMessage,eax,WM_SETFONT,hFont, 0
	pop	eax
	ret

cGroupButton endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
cButton proc hParent:DWORD,lpText:DWORD,x:DWORD,y:DWORD,w:DWORD,h:DWORD,ID:DWORD
	LOCAL hFont :DWORD

	invoke	GetStockObject,ANSI_VAR_FONT
	mov	hFont, eax
	
	invoke	CreateWindowEx,0,S('BUTTON'),lpText,WS_CHILD or WS_VISIBLE or BS_FLAT ,
			x,y,w,h,hParent,ID,
			hInstance,NULL
	push	eax
	invoke	SendMessage,eax,WM_SETFONT,hFont, 0
	pop	eax
	ret

cButton endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
cListView proc hParent:DWORD, x:DWORD,y:DWORD,w:DWORD,h:DWORD,ID:DWORD
	LOCAL hFont :DWORD

	invoke  CreateFont,14,0,0,0,FW_NORMAL,FALSE,FALSE,FALSE, \
		    ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS, \
		    DEFAULT_QUALITY,DEFAULT_PITCH, S("MS Sans Serif")
	mov	hFont, eax

	invoke	CreateWindowEx, WS_EX_CLIENTEDGE or WS_EX_WINDOWEDGE or WS_EX_TOOLWINDOW,\
		S("SysListView32"),S("Filter"),LVS_REPORT + WS_BORDER + \
		WS_TABSTOP +WS_VSCROLL+ES_AUTOHSCROLL+WS_VISIBLE+WS_CHILD,x,y,w,h,\
		hParent,ID,hInstance,NULL
	push	eax
	invoke	SendMessage,eax,WM_SETFONT,hFont, 0
	pop	eax
	ret

cListView endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
cAutoCheck proc hParent:DWORD,lpText:DWORD, x:DWORD,y:DWORD,w:DWORD,h:DWORD,ID:DWORD
	LOCAL hFont :DWORD

	invoke  CreateFont,14,0,0,0,FW_NORMAL,FALSE,FALSE,FALSE, \
		    ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS, \
		    DEFAULT_QUALITY,DEFAULT_PITCH, S("MS Sans Serif")
	mov	hFont, eax
	
	invoke	CreateWindowEx,0,S("BUTTON"),lpText,\
		BS_AUTOCHECKBOX+WS_VISIBLE+WS_CHILD,x,y,w,h,hParent,ID,hInstance,NULL
	push	eax
	invoke	SendMessage,eax,WM_SETFONT,hFont, 0
	pop	eax
	ret

cAutoCheck endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
cInEditText proc hParent:DWORD, x:DWORD,y:DWORD,w:DWORD,h:DWORD,ID:DWORD
	LOCAL hFont :DWORD

	invoke  CreateFont,14,0,0,0,FW_NORMAL,FALSE,FALSE,FALSE, \
		    ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS, \
		    DEFAULT_QUALITY,DEFAULT_PITCH, S("MS Sans Serif")
	mov	hFont, eax
	
	invoke CreateWindowEx,WS_EX_CLIENTEDGE or WS_EX_WINDOWEDGE or WS_EX_TOOLWINDOW,\
		S("EDIT"),0,ES_LEFT+WS_VISIBLE+WS_CHILD,x,y,w,h,\
		hParent,ID,hInstance,NULL
	push	eax
	invoke	SendMessage,eax,WM_SETFONT,hFont, 0
	pop	eax
	ret

cInEditText endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
cEditView proc hParent:DWORD, x:DWORD,y:DWORD,w:DWORD,h:DWORD,ID:DWORD
	LOCAL hFont :DWORD

	invoke  CreateFont,14,0,0,0,FW_NORMAL,FALSE,FALSE,FALSE, \
		    ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS, \
		    DEFAULT_QUALITY,DEFAULT_PITCH, S("MS Sans Serif")
	mov	hFont, eax

	invoke CreateWindowEx,WS_EX_CLIENTEDGE or WS_EX_WINDOWEDGE or WS_EX_TOOLWINDOW,\
		S("EDIT"),0,ES_LEFT+ES_MULTILINE+ES_AUTOHSCROLL \
		+ ES_READONLY+WS_BORDER+WS_HSCROLL+WS_VISIBLE+WS_CHILD,x,y,w,h,\
		hParent,ID,hInstance,NULL
	push	eax
	invoke	SendMessage,eax,WM_SETFONT,hFont, 0
	pop	eax
	ret

cEditView endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
LimitWndProc PROC hEditt:DWORD,uMsg1:DWORD,wParam1:DWORD,lParam1:DWORD
	LOCAL hParent		:DWORD
	LOCAL idCtrl		:DWORD
	LOCAL lpTranslated	:DWORD
	LOCAL OldValue		:DWORD
	LOCAL Limit		:DWORD

	.if uMsg1==WM_CHAR || uMsg1==WM_PASTE 
		invoke GetParent,hEditt
		mov hParent,eax
		invoke GetDlgCtrlID,hEditt
		mov idCtrl,eax
		invoke GetWindowLong,hEditt,GWL_USERDATA
		mov Limit,eax
		invoke GetDlgItemInt, hParent, idCtrl, ADDR lpTranslated, FALSE
		mov OldValue,eax
		invoke CallWindowProc, OldWndProc, hEditt, uMsg1, wParam1, lParam1
		push eax
		invoke GetDlgItemInt, hParent, idCtrl,ADDR lpTranslated, FALSE
		.IF eax > Limit || lpTranslated == FALSE
			invoke MessageBeep,MB_ICONHAND	
			invoke SetDlgItemInt,hParent,idCtrl,OldValue,FALSE
		.endif
		pop eax
	.else
		invoke CallWindowProc, OldWndProc, hEditt, uMsg1, wParam1, lParam1
	.endif
	ret
LimitWndProc endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
memcpy proc uses edi esi ecx pDest:dword, pSource:dword, SizeByte:dword
	mov     ecx, SizeByte
        mov     esi, pSource
        mov     edi, pDest
        mov     eax, ecx
        shr     ecx, 2
        rep	movsd
        mov     ecx, eax
        and     ecx, 3
        rep	movsb
        ret
memcpy endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
DelListColumn proc uses ebx iCol:DWORD
	mov	ebx,iCol
	invoke	SendMessage,hList,LVM_DELETECOLUMN,ebx,0
	ret
DelListColumn endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
FreshListGUI proc uses ebx mStyle:DWORD,bStyle:DWORD
	
	invoke	DelListColumn,2	
	.if	mStyle==0
		invoke	EnableWindow, hMarch, TRUE	
	.else
		invoke	EnableWindow, hMarch, FALSE	
	.endif
	
	.if	mStyle==4
		invoke	AddColumnHeader,hList,80d,S('Size (Bytes)')
	.elseif	mStyle==5
		.if	bStyle==1
			invoke	AddColumnHeader,hList,120d,S('CreationDate')
		.elseif bStyle==2
			invoke	AddColumnHeader,hList,120d,S('LastAccessDate')
		.elseif bStyle==3
			invoke	AddColumnHeader,hList,120d,S('LastWriteDate')
		.endif
	.elseif	mStyle==6
		.if	bStyle==1
			invoke	AddColumnHeader,hList,120d,S('CreationTime')
		.elseif bStyle==2
			invoke	AddColumnHeader,hList,120d,S('LastAccessTime')
		.elseif bStyle==3
			invoke	AddColumnHeader,hList,120d,S('LastWriteTime')
		.endif
	.endif
	
	invoke	SendMessage,hMain,WM_SIZE,0,0
	ret
FreshListGUI endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
AdvanceDlg proc uses ecx edx esi edi hWin1:HWND,uMsg1:UINT,wParam1:WPARAM,lParam1:LPARAM
	local dwBytesTouched:dword
	Local @YearA,@MonA,@DatA,@HourA,@MinA,@SecA:dword
	Local bufSize[32]:byte
	Local buf1[5]:byte
	local buf2[3]:byte
	Local buf3[3]:byte
	local buf4[3]:byte
	Local buf5[3]:byte
	local buf6[3]:byte
	Local @YearB,@MonB,@DatB,@HourB,@MinB,@SecB:dword
	
	mov eax,uMsg1
	.if eax==WM_INITDIALOG
		
		invoke	RtlZeroMemory, addr buf1 , sizeof buf1
		invoke	RtlZeroMemory, addr buf2 , sizeof buf2
		invoke	RtlZeroMemory, addr buf3 , sizeof buf3
		invoke	RtlZeroMemory, addr buf4 , sizeof buf4
		invoke	RtlZeroMemory, addr buf5 , sizeof buf5
		invoke	RtlZeroMemory, addr buf6 , sizeof buf6
		
		invoke	LoadIcon,hInstance, ICO_ICON
		invoke	SendMessage, hWin1, WM_SETICON, ICON_SMALL or ICON_BIG, eax
		
		invoke	CheckDlgButton,hWin1,IDC_RADIO1,BST_CHECKED	; Initialise recording mode as default
		invoke	CheckDlgButton,hWin1,IDC_RADIO6,BST_CHECKED
		invoke	CheckDlgButton,hWin1,IDC_RADIO7,BST_CHECKED
		invoke	CheckDlgButton,hWin1,IDC_RADIO10,BST_CHECKED
		invoke	CheckDlgButton,hWin1,IDC_CHK1,BST_CHECKED
		
		invoke  GetDlgItem,hWin1,IDC_EDT1
		mov	hEdt1, eax		    	
		invoke  GetDlgItem,hWin1,IDC_EDT2
		mov	hEdt2, eax
		invoke  GetDlgItem,hWin1,IDC_EDT3
		mov	hEdt3, eax		    	
		invoke  GetDlgItem,hWin1,IDC_EDT4
		mov	hEdt4, eax		    	
		invoke  GetDlgItem,hWin1,IDC_EDT5
		mov	hEdt5, eax		    	
		invoke  GetDlgItem,hWin1,IDC_EDT6
		mov	hEdt6, eax		    	
		invoke  GetDlgItem,hWin1,IDC_EDT7
		mov	hEdt7, eax		    	
		invoke  GetDlgItem,hWin1,IDC_EDT8
		mov	hEdt8, eax		    	
		invoke  GetDlgItem,hWin1,IDC_EDT9
		mov	hEdt9, eax		    	
		invoke  GetDlgItem,hWin1,IDC_EDT10
		mov	hEdt10, eax		    	
		invoke  GetDlgItem,hWin1,IDC_EDT11
		mov	hEdt11, eax		    	
		invoke  GetDlgItem,hWin1,IDC_EDT12
		mov	hEdt12, eax		    	
		invoke  GetDlgItem,hWin1,IDC_EDT13
		mov	hEdt13, eax		    	
		invoke  GetDlgItem,hWin1,IDC_EDT14
		mov	hEdt14, eax		    	

		invoke  GetDlgItem,hWin1,IDC_OPEN1
		mov	hOpen1, eax		    	
		invoke  GetDlgItem,hWin1,IDC_OPEN2
		mov	hOpen2, eax		    	

		invoke  GetDlgItem,hWin1,IDC_RADIO1
		mov	hRADIO1, eax		    	
		invoke  GetDlgItem,hWin1,IDC_RADIO2
		mov	hRADIO2, eax		    	
		invoke  GetDlgItem,hWin1,IDC_RADIO3
		mov	hRADIO3, eax		    	
		invoke  GetDlgItem,hWin1,IDC_RADIO4
		mov	hRADIO4, eax		    	
		invoke  GetDlgItem,hWin1,IDC_RADIO5
		mov	hRADIO5, eax		    	
		invoke  GetDlgItem,hWin1,IDC_RADIO6
		mov	hRADIO6, eax		    	
		invoke  GetDlgItem,hWin1,IDC_RADIO7
		mov	hRADIO7, eax		    	
		invoke  GetDlgItem,hWin1,IDC_RADIO8
		mov	hRADIO8, eax		    	
		invoke  GetDlgItem,hWin1,IDC_RADIO9
		mov	hRADIO9, eax		    	
		invoke  GetDlgItem,hWin1,IDC_RADIO10
		mov	hRADIO10, eax		    	
		invoke  GetDlgItem,hWin1,IDC_RADIO11
		mov	hRADIO11, eax		    	
		invoke  GetDlgItem,hWin1,IDC_RADIO12
		mov	hRADIO12, eax		    	
		
		invoke  GetDlgItem,hWin1,IDC_COMBOX
		mov	hComBox, eax		    	
		
		invoke  GetDlgItem,hWin1,IDC_DATE1
		mov	hDate1, eax		    	
		invoke  GetDlgItem,hWin1,IDC_DATE2
		mov	hDate2, eax		    	
		
		invoke  GetDlgItem,hWin1,IDC_SPIN1
		mov	hSpin1, eax		    	
		invoke  GetDlgItem,hWin1,IDC_SPIN2
		mov	hSpin2, eax		    	
		invoke  GetDlgItem,hWin1,IDC_SPIN3
		mov	hSpin3, eax		    	
		invoke  GetDlgItem,hWin1,IDC_SPIN4
		mov	hSpin4, eax		    	
		invoke  GetDlgItem,hWin1,IDC_SPIN5
		mov	hSpin5, eax		    	
		invoke  GetDlgItem,hWin1,IDC_SPIN6
		mov	hSpin6, eax		    	
		
		invoke	EnableWindow, hEdt3, FALSE	
		invoke	EnableWindow, hEdt4, FALSE	
		invoke	EnableWindow, hEdt5, FALSE	
		invoke	EnableWindow, hEdt6, FALSE	
		invoke	EnableWindow, hEdt7, FALSE	
		invoke	EnableWindow, hEdt8, FALSE	
		invoke	EnableWindow, hEdt14, FALSE	
		
		invoke	EnableWindow, hRADIO1, FALSE	
		invoke	EnableWindow, hRADIO2, FALSE	
		invoke	EnableWindow, hRADIO3, FALSE	
		invoke	EnableWindow, hRADIO7, FALSE	
		invoke	EnableWindow, hRADIO8, FALSE	
		invoke	EnableWindow, hRADIO9, FALSE	
		
		invoke	EnableWindow, hDate1, FALSE	
		invoke	EnableWindow, hDate2, FALSE	
		
		invoke	EnableWindow, hSpin1, FALSE	
		invoke	EnableWindow, hSpin2, FALSE	
		invoke	EnableWindow, hSpin3, FALSE	
		invoke	EnableWindow, hSpin4, FALSE	
		invoke	EnableWindow, hSpin5, FALSE	
		invoke	EnableWindow, hSpin6, FALSE	
		
		invoke	RtlZeroMemory, offset Shellpath, sizeof Shellpath
		invoke	szCopy,offset Shellpath,S("c:\windows\system32\notepad.exe") ;default shellexec		
		invoke	SetWindowText,hEdt14,offset Shellpath
		
		invoke	SendDlgItemMessage,hWin1,IDC_SPIN1,UDM_SETRANGE32,0,23
		invoke	SendDlgItemMessage,hWin1,IDC_SPIN2,UDM_SETRANGE32,0,59
		invoke	SendDlgItemMessage,hWin1,IDC_SPIN3,UDM_SETRANGE32,0,59
		invoke	SendDlgItemMessage,hWin1,IDC_SPIN4,UDM_SETRANGE32,0,23
		invoke	SendDlgItemMessage,hWin1,IDC_SPIN5,UDM_SETRANGE32,0,59
		invoke	SendDlgItemMessage,hWin1,IDC_SPIN6,UDM_SETRANGE32,0,59
		
		invoke	SetWindowLong,hEdt8,GWL_WNDPROC,OFFSET LimitWndProc
		mov	OldWndProc,eax
		invoke	SetWindowLong,hEdt8,GWL_USERDATA,23 ; upper limit to number (23)
		
		invoke	SetWindowLong,hEdt9,GWL_WNDPROC,OFFSET LimitWndProc
		mov	OldWndProc,eax
		invoke	SetWindowLong,hEdt9,GWL_USERDATA,59 
		
		invoke	SetWindowLong,hEdt10,GWL_WNDPROC,OFFSET LimitWndProc
		mov	OldWndProc,eax
		invoke	SetWindowLong,hEdt10,GWL_USERDATA,59 
		
		invoke	SetWindowLong,hEdt11,GWL_WNDPROC,OFFSET LimitWndProc
		mov	OldWndProc,eax
		invoke	SetWindowLong,hEdt11,GWL_USERDATA,23 
		
		invoke	SetWindowLong,hEdt12,GWL_WNDPROC,OFFSET LimitWndProc
		mov	OldWndProc,eax
		invoke	SetWindowLong,hEdt12,GWL_USERDATA,59 
		
		invoke	SetWindowLong,hEdt13,GWL_WNDPROC,OFFSET LimitWndProc
		mov	OldWndProc,eax
		invoke	SetWindowLong,hEdt13,GWL_USERDATA,59 

		invoke	SendMessage,hComBox,CB_ADDSTRING,0,S("B")
		invoke	SendMessage,hComBox,CB_ADDSTRING,0,S("K")
		invoke	SendMessage,hComBox,CB_ADDSTRING,0,S("M")
		invoke	SendMessage,hComBox,CB_ADDSTRING,0,S("G")
		invoke	SendMessage,hComBox,CB_SETCURSEL,1,0

	.elseif eax==WM_COMMAND
		invoke IsDlgButtonChecked, hWin1, IDC_CHK1
		.if eax == BST_CHECKED
			invoke	EnableWindow, hEdt1, TRUE	
			invoke	EnableWindow, hEdt2, TRUE	
		.else
			invoke	EnableWindow, hEdt1, FALSE	
			invoke	EnableWindow, hEdt2, FALSE	
		.endif

		invoke IsDlgButtonChecked, hWin1, IDC_CHK2
		.if eax == BST_CHECKED
			invoke	EnableWindow, hEdt3, TRUE	
			invoke	EnableWindow, hEdt4, TRUE	
		.else
			invoke	EnableWindow, hEdt3, FALSE	
			invoke	EnableWindow, hEdt4, FALSE	
		.endif

		invoke IsDlgButtonChecked, hWin1, IDC_CHK3
		.if eax == BST_CHECKED
			invoke	EnableWindow, hEdt5, TRUE	
			invoke	EnableWindow, hOpen1, TRUE	
		.else
			invoke	EnableWindow, hOpen1, FALSE	
			invoke	EnableWindow, hEdt5, FALSE	
		.endif
		
		invoke IsDlgButtonChecked, hWin1, IDC_CHK4	;size
		.if eax == BST_CHECKED
			invoke	EnableWindow, hRADIO1, TRUE	
			invoke	EnableWindow, hRADIO2, TRUE	
			invoke	EnableWindow, hRADIO3, TRUE	
			invoke	EnableWindow, hEdt6, TRUE	
			invoke	EnableWindow, hComBox, TRUE	
		.else
			invoke	EnableWindow, hEdt6, FALSE	
			invoke	EnableWindow, hComBox, FALSE	
			invoke	EnableWindow, hEdt7, FALSE	
			invoke	EnableWindow, hRADIO1, FALSE	
			invoke	EnableWindow, hRADIO2, FALSE	
			invoke	EnableWindow, hRADIO3, FALSE	
		.endif
		
		invoke IsDlgButtonChecked, hWin1, IDC_CHK5	;date
		.if eax == BST_CHECKED
			invoke	EnableWindow, hRADIO7, TRUE	
			invoke	EnableWindow, hRADIO8, TRUE	
			invoke	EnableWindow, hRADIO9, TRUE	
			invoke	EnableWindow, hDate1, TRUE	
		.else
			invoke	EnableWindow, hDate1, FALSE	
			invoke	EnableWindow, hDate2, FALSE	
			invoke	EnableWindow, hRADIO7, FALSE	
			invoke	EnableWindow, hRADIO8, FALSE	
			invoke	EnableWindow, hRADIO9, FALSE	
		.endif
		
		invoke IsDlgButtonChecked, hWin1, IDC_CHK6	;time
		.if eax == BST_CHECKED
			invoke	EnableWindow, hRADIO10, TRUE	
			invoke	EnableWindow, hRADIO11, TRUE	
			invoke	EnableWindow, hRADIO12, TRUE
			invoke	EnableWindow, hEdt8, TRUE	
			invoke	EnableWindow, hEdt9, TRUE	
			invoke	EnableWindow, hEdt10, TRUE	
			invoke	EnableWindow, hSpin1, TRUE	
			invoke	EnableWindow, hSpin2, TRUE	
			invoke	EnableWindow, hSpin3, TRUE	
		.else
			invoke	EnableWindow, hRADIO10, FALSE	
			invoke	EnableWindow, hRADIO11, FALSE	
			invoke	EnableWindow, hRADIO12, FALSE
			
			invoke	EnableWindow, hEdt8, FALSE	
			invoke	EnableWindow, hEdt9, FALSE	
			invoke	EnableWindow, hEdt10, FALSE	
			invoke	EnableWindow, hEdt11, FALSE	
			invoke	EnableWindow, hEdt12, FALSE	
			invoke	EnableWindow, hEdt13, FALSE	
			
			invoke	EnableWindow, hSpin1, FALSE	
			invoke	EnableWindow, hSpin2, FALSE	
			invoke	EnableWindow, hSpin3, FALSE	
			invoke	EnableWindow, hSpin4, FALSE	
			invoke	EnableWindow, hSpin5, FALSE	
			invoke	EnableWindow, hSpin6, FALSE	
		.endif
		
		mov	eax,wParam1
		.if eax==IDC_OPEN1
			invoke	RtlZeroMemory, addr CmpPath, sizeof CmpPath
			invoke	GetPathAndNameFromDLG,hWin1,offset CmpPath
			invoke	SetWindowText,hEdt5,offset CmpPath
		.elseif eax==IDC_OPEN2
			invoke	RtlZeroMemory, addr Shellpath, sizeof Shellpath
			invoke	GetPathAndNameFromDLG,hWin1,offset Shellpath
			invoke	SetWindowText,hEdt14,offset Shellpath
		.endif
		
		mov	ebx,wParam1
		and	ebx,0ffffh
		.if ebx==IDC_RADIO1				;size, x>a
			invoke	EnableWindow, hEdt6, TRUE	
			invoke	EnableWindow, hEdt7, FALSE
			mov	cCmpStyle,0	
		.elseif ebx==IDC_RADIO2				;size, b>= x >=a
			invoke	EnableWindow, hEdt6, TRUE	
			invoke	EnableWindow, hEdt7, TRUE
			mov	cCmpStyle,1	
		.elseif ebx==IDC_RADIO3				;size, x<a
			invoke	EnableWindow, hEdt6, TRUE	
			invoke	EnableWindow, hEdt7, FALSE
			mov	cCmpStyle,2	
		
		.elseif ebx==IDC_RADIO7				;Date, x>a
			invoke	EnableWindow, hDate2, FALSE
			mov	cCmpStyle,0	
		.elseif ebx==IDC_RADIO8				;Date, b>= x >=a
			invoke	EnableWindow, hDate2, TRUE	
			mov	cCmpStyle,1	
		.elseif ebx==IDC_RADIO9				;Date, x<a
			invoke	EnableWindow, hDate2, FALSE	
			mov	cCmpStyle,2	
			
		.elseif ebx==IDC_RADIO10			;time, x>a
			invoke	EnableWindow, hEdt11, FALSE	
			invoke	EnableWindow, hEdt12, FALSE	
			invoke	EnableWindow, hEdt13, FALSE	
			invoke	EnableWindow, hSpin4, FALSE	
			invoke	EnableWindow, hSpin5, FALSE	
			invoke	EnableWindow, hSpin6, FALSE
			mov	cCmpStyle,0	
		.elseif ebx==IDC_RADIO11			;time, b>= x >=a
			invoke	EnableWindow, hEdt11, TRUE	
			invoke	EnableWindow, hEdt12, TRUE	
			invoke	EnableWindow, hEdt13, TRUE	
			invoke	EnableWindow, hSpin4, TRUE	
			invoke	EnableWindow, hSpin5, TRUE	
			invoke	EnableWindow, hSpin6, TRUE
			mov	cCmpStyle,1	
		.elseif ebx==IDC_RADIO12			;time, x<a
			invoke	EnableWindow, hEdt11, FALSE	
			invoke	EnableWindow, hEdt12, FALSE	
			invoke	EnableWindow, hEdt13, FALSE	
			invoke	EnableWindow, hSpin4, FALSE	
			invoke	EnableWindow, hSpin5, FALSE	
			invoke	EnableWindow, hSpin6, FALSE
			mov	cCmpStyle,2	
		
		.endif

		mov    eax,wParam1
		.if    ax == IDC_OK
			invoke	IsDlgButtonChecked, hWin1, IDC_CHK1	
			.if eax == BST_CHECKED
				invoke	RtlZeroMemory,addr BufAdv1,sizeof BufAdv1
				invoke	RtlZeroMemory,addr BufAdv2,sizeof BufAdv2
				invoke	GetWindowText,hEdt1,offset BufAdv1,256
				invoke	GetWindowText,hEdt2,offset BufAdv2,256
				mov	SearchStyle,1		;name
				invoke	FreshListGUI,SearchStyle,dDateStyle
			.else
				invoke IsDlgButtonChecked, hWin1, IDC_CHK2
				.if	eax== BST_CHECKED
					invoke	RtlZeroMemory,addr BufAdv1,sizeof BufAdv1
					invoke	RtlZeroMemory,addr BufAdv2,sizeof BufAdv2
					invoke	GetWindowText,hEdt3,offset BufAdv1,256
					invoke	GetWindowText,hEdt4,offset BufAdv2,256
					mov	SearchStyle,2	;content	
					invoke	FreshListGUI,SearchStyle,dDateStyle
				.else
					invoke IsDlgButtonChecked, hWin1, IDC_CHK3	
					.if	eax== BST_CHECKED	;Content(disk)
;//-----------------------------------------------------------------------------------------------------------------------------------------------			
						invoke	CreateFile, offset CmpPath, GENERIC_READ, FILE_SHARE_READ, NULL,OPEN_EXISTING,\
							FILE_ATTRIBUTE_ARCHIVE, NULL
						.if	eax!=INVALID_HANDLE_VALUE
							mov	hFileDisk,eax
							invoke	GetFileSize, hFileDisk, NULL
							mov	DiskFileLen,eax
							invoke	HeapAlloc,hHeap,HEAP_ZERO_MEMORY, DiskFileLen
							mov	DiskMemAddr,eax
							invoke	ReadFile,hFileDisk,DiskMemAddr,DiskFileLen,ADDR dwBytesTouched,0
						.else
							invoke	MessageBox,0,S("Error"),S("in content(disk)"),MB_OK
						.endif
;//-----------------------------------------------------------------------------------------------------------------------------------------------			
						mov	SearchStyle,3		;Content(disk)
						invoke	FreshListGUI,SearchStyle,dDateStyle
					.else
						invoke IsDlgButtonChecked, hWin1, IDC_CHK4 	
						.if	eax== BST_CHECKED	;size
							invoke	RtlZeroMemory, addr bufSize,sizeof bufSize
							invoke	GetWindowText,hEdt6,addr bufSize,32
							invoke	atodw,addr bufSize
							mov	cSizeA,eax
							.if	cCmpStyle==1
								invoke	RtlZeroMemory, addr bufSize,sizeof bufSize
								invoke	GetWindowText,hEdt7,addr bufSize,32
								invoke	atodw,addr bufSize
								mov	cSizeB,eax
							.else
								mov	cSizeB,0
							.endif
							invoke	SendMessage,hComBox,CB_GETCURSEL,0,0
							.if	eax ==	1
								xor	edx,edx
								mov	eax,1000
								mul	cSizeA
								mov	cSizeA,eax
								
								xor	edx,edx
								mov	eax,1000
								mul	cSizeB
								mov	cSizeB,eax
							.elseif	eax ==	2
								xor	edx,edx
								mov	eax,1000000
								mul	cSizeA
								mov	cSizeA,eax
								
								xor	edx,edx
								mov	eax,1000000
								mul	cSizeB
								mov	cSizeB,eax
							.elseif	eax ==	3
								xor	edx,edx
								mov	eax,1000000000
								mul	cSizeA
								mov	cSizeA,eax
								
								xor	edx,edx
								mov	eax,1000000000
								mul	cSizeB
								mov	cSizeB,eax
							.endif
							mov	SearchStyle,4	;size	
							invoke	FreshListGUI,SearchStyle,dDateStyle
						.else
							invoke IsDlgButtonChecked, hWin1, IDC_CHK5
							.if	eax== BST_CHECKED	;date
								invoke IsDlgButtonChecked, hWin1, IDC_RADIO4
								.if	eax==BST_CHECKED
									mov	dDateStyle,1 ;Create
								.else
									invoke IsDlgButtonChecked, hWin1, IDC_RADIO5
									.if	eax==BST_CHECKED
										mov	dDateStyle,2 ;lastAccess
									.else
										invoke IsDlgButtonChecked, hWin1, IDC_RADIO6
										.if	eax==BST_CHECKED
											mov	dDateStyle,3 ;lastWrite
										.endif
									.endif
								.endif
								.if	cCmpStyle==1
									invoke	RtlZeroMemory, offset BufAdv1,sizeof BufAdv1
									invoke	GetWindowText,hDate1,offset BufAdv1,32
								
									lea	esi,BufAdv1
									xor	ecx,ecx
									.repeat
										inc ecx
									.until	byte ptr [esi+ecx] == "-"
									invoke	memcpy,addr buf1, esi, ecx
									inc	esi
									add	esi,ecx
									invoke	atodw,addr buf1
									mov	@YearA,eax
									mov	bx,word ptr @YearA
									mov	cDateA.wYear,bx
								
									xor	ecx,ecx
									.repeat
										inc ecx
									.until	byte ptr [esi+ecx] == "-"
									invoke	memcpy,addr buf2, esi, ecx                                                                              
									inc	esi
									add	esi,ecx
									invoke	atodw,addr buf2
									mov	@MonA,eax
									mov	bx,word ptr @MonA
									mov	cDateA.wMonth,bx
								
									xor	ecx,ecx
									.repeat
										inc ecx
									.until	byte ptr [esi+ecx] == 0
									invoke	memcpy,addr buf3, esi, ecx                                                                              
									invoke	atodw,addr buf3
									mov	@DatA,eax
									mov	bx,word ptr @DatA
									mov	cDateA.wDay,bx
								
									invoke	RtlZeroMemory, offset BufAdv2,sizeof BufAdv2
									invoke	GetWindowText,hDate2,offset BufAdv2,Sizeof BufAdv2
									lea	esi,BufAdv2
									xor	ecx,ecx
									.repeat
										inc ecx
									.until	byte ptr [esi+ecx] == "-"
									invoke	memcpy,addr buf1, esi, ecx
									inc	esi
									add	esi,ecx
									invoke	atodw,addr buf1
									mov	@YearB,eax
									mov	bx,word ptr @YearB
									mov	cDateB.wYear,bx
								
									xor	ecx,ecx
									.repeat
										inc ecx
									.until	byte ptr [esi+ecx] == "-"
									invoke	memcpy,addr buf2, esi, ecx                                                                              
									inc	esi
									add	esi,ecx
									invoke	atodw,addr buf2
									mov	@MonB,eax
									mov	bx,word ptr @MonB
									mov	cDateB.wMonth,bx
								
									xor	ecx,ecx
									.repeat
										inc ecx
									.until	byte ptr [esi+ecx] == 0
									invoke	memcpy,addr buf3, esi, ecx                                                                              
									invoke	atodw,addr buf3
									mov	@DatB,eax
									mov	bx,word ptr @DatB
									mov	cDateB.wDay,bx
								
									invoke	CompareSystemTimeD,cDateA,cDateB
									.if	eax==1
										invoke	MessageBox,0,S("Error! B shoud bigger than A."),0,MB_OK
									.endif
								.else
									invoke	RtlZeroMemory, offset BufAdv1,sizeof BufAdv1
									invoke	GetWindowText,hDate1,offset BufAdv1,sizeof BufAdv1
									lea	esi,BufAdv1
									xor	ecx,ecx
									.repeat
										inc ecx
									.until	byte ptr [esi+ecx] == "-"
									invoke	memcpy,addr buf1, esi, ecx
									inc	esi
									add	esi,ecx
									invoke	atodw,addr buf1
									mov	@YearA,eax
									mov	bx,word ptr @YearA
									mov	cDateA.wYear,bx
									
									xor	ecx,ecx
									.repeat
										inc ecx
									.until	byte ptr [esi+ecx] == "-"
									invoke	memcpy,addr buf2, esi, ecx                                                                              
									inc	esi
									add	esi,ecx
									invoke	atodw,addr buf2
									mov	@MonA,eax
									mov	bx,word ptr @MonA
									mov	cDateA.wMonth,bx
									
									xor	ecx,ecx
									.repeat
										inc ecx
									.until	byte ptr [esi+ecx] == 0
									invoke	memcpy,addr buf3, esi, ecx                                                                              
									invoke	atodw,addr buf3
									mov	@DatA,eax
									mov	bx,word ptr @DatA
									mov	cDateA.wDay,bx
								.endif
						
								mov	SearchStyle,5		;date
								invoke	FreshListGUI,SearchStyle,dDateStyle
							.else
								invoke IsDlgButtonChecked, hWin1, IDC_CHK6 
								.if	eax== BST_CHECKED	;time
									invoke IsDlgButtonChecked, hWin1, IDC_RADIO4
									.if	eax==BST_CHECKED
										mov	dDateStyle,1 ;Create
									.else
										invoke IsDlgButtonChecked, hWin1, IDC_RADIO5
										.if	eax==BST_CHECKED
											mov	dDateStyle,2 ;lastAccess
										.else
											invoke IsDlgButtonChecked, hWin1, IDC_RADIO6
											.if	eax==BST_CHECKED
												mov	dDateStyle,3 ;lastWrite
											.endif
										.endif
									.endif
									.if	cCmpStyle==1
										invoke	RtlZeroMemory, offset cTimeA,sizeof cTimeA
										invoke	RtlZeroMemory, offset cTimeB,sizeof cTimeB
										
										invoke	GetWindowText,hEdt8,addr buf1,5
										invoke	atodw,addr buf1
										mov	@HourA,eax ;@HourA,@MinA,@SecA
										mov	bx,word ptr @HourA
										mov	cTimeA.wHour,bx

										invoke	GetWindowText,hEdt9,addr buf2,3
										invoke	atodw,addr buf2
										mov	@MinA,eax
										mov	bx,word ptr @MinA
										mov	cTimeA.wMinute,bx
										
										invoke	GetWindowText,hEdt10,addr buf3,3
										invoke	atodw,addr buf3
										mov	@SecA,eax
										mov	bx,word ptr @SecA
										mov	cTimeA.wSecond,bx
										
										invoke	GetWindowText,hEdt11,addr buf4,3
										invoke	atodw,addr buf4
										mov	@HourB,eax
										mov	bx,word ptr @HourB
										mov	cTimeB.wHour,bx
										
										invoke	GetWindowText,hEdt12,addr buf5,3
										invoke	atodw,addr buf5
										mov	@MinB,eax
										mov	bx,word ptr @MinB
										mov	cTimeB.wMinute,bx
										
										invoke	GetWindowText,hEdt13,addr buf6,3
										invoke	atodw,addr buf6
										mov	@SecB,eax
										mov	bx,word ptr @SecB
										mov	cTimeB.wSecond,bx
										
										invoke	CompareSystemTimeT,cTimeA,cTimeB
										.if	eax==1
											invoke	MessageBox,0,S("Error! B shoud bigger than A."),0,MB_OK
										.endif
										
									.else
										invoke	GetWindowText,hEdt8,addr buf1,2
										invoke	atodw,addr buf1
										mov	@HourA,eax ;@HourA,@MinA,@SecA
										mov	bx,word ptr @HourA
										mov	cTimeA.wHour,bx

										invoke	GetWindowText,hEdt9,addr buf2,2
										invoke	atodw,addr buf2
										mov	@MinA,eax
										mov	bx,word ptr @MinA
										mov	cTimeA.wMinute,bx
										
										invoke	GetWindowText,hEdt10,addr buf3,2
										invoke	atodw,addr buf3
										mov	@SecA,eax
										mov	bx,word ptr @SecA
										mov	cTimeA.wSecond,bx
									.endif
									
									mov	SearchStyle,6	;time	
									invoke	FreshListGUI,SearchStyle,dDateStyle
								.endif
							.endif
						.endif
					.endif
				.endif
			.endif
			invoke	EndDialog,hWin1,NULL
		.endif
	.elseif eax==WM_CLOSE  
		mov	SearchStyle,0		
		invoke	FreshListGUI,SearchStyle,dDateStyle
		invoke	EndDialog,hWin1,NULL
	.elseif eax==WM_DESTROY       
		invoke	EndDialog,hWin1,NULL
	.endif
	mov eax,0
	ret
AdvanceDlg endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
EnumDrivers proc uses esi edi Parameter:dword
	Local DriveNames[255]:byte

	invoke	RtlZeroMemory,addr DriveNames,255
	invoke	GetLogicalDriveStrings,255,addr DriveNames
	lea	edi,DriveNames
	.repeat
		push	edi
		invoke	RtlZeroMemory,offset FileN,sizeof FileN
		;	edi=d:\
		invoke	lstrcpy,offset FileN,edi
		invoke	lstrlen,offset FileN
		add	eax,offset FileN	; location of zero byte terminator
		mov	pFile,eax  
		lea	esi,FileN			
		invoke	CreateThread, 0, 0, offset SearchForFile, esi, 0, 0
		push	eax
		invoke	WaitForSingleObject,eax,INFINITE
		pop	eax
		invoke	CloseHandle,eax
		pop	edi
		add	edi,4
	.until dword ptr [edi]==0
	ret
EnumDrivers endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
NewSearch proc

	invoke	RtlZeroMemory,offset FileN,sizeof FileN
	invoke	GetWindowText,hDir, offset FileN,sizeof FileN
	invoke	lstrlen,offset FileN
	mov	SearchDirLen,eax
	add	eax,offset FileN	; location of zero byte terminator
	mov	pFile,eax  
				
	mov	ListViewStrLen,0
	lea	esi,FileN			
	.if	SearchDirLen==1 && byte ptr[esi]=="*"
		invoke	CreateThread, 0, 0, offset EnumDrivers, 0, 0, 0
	.else
		invoke	CreateThread, 0, 0, offset SearchForFile, esi, 0, 0
	.endif
	ret

NewSearch endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
AgainSearch proc uses esi edi TatalIndex:dword
	Local SaveListBuf:dword				
	Local SaveLineLenBuf:dword

	invoke	EnterCriticalSection,ADDR stCS
	
	mov	ebx,ListViewStrLen
	invoke	HeapAlloc,hHeap,HEAP_ZERO_MEMORY, ebx
	mov	SaveListBuf,eax
	
	mov	ebx,TatalIndex
	shl	ebx,2
	invoke	HeapAlloc,hHeap,HEAP_ZERO_MEMORY, ebx
	mov	SaveLineLenBuf,eax
	
	mov	esi,SaveLineLenBuf
	xor	ebx,ebx
	.repeat
		push	ebx
		invoke	GetItemStr,ebx,1
		push	eax
		invoke	lstrcat,SaveListBuf,eax		;Save ListView
		pop	eax
		invoke	lstrlen,eax
		pop	ebx
		mov	[esi+ebx*4],eax		;save the Length of everyline
		inc	ebx
	.until	ebx==TatalIndex
	
	invoke	SendMessage, hList, LVM_DELETEALLITEMS, 0h, 0h	;clear list
	mov	FoundLineIndex,0
	mov	ListViewStrLen,0
	
	invoke	RtlZeroMemory,addr BufEdit,sizeof BufEdit
	invoke	SetDlgItemText,hMain,ID_EDIT,addr BufEdit
	mov	CheckLineIndex,0
	mov	lineNum,0
	
	mov	esi,SaveLineLenBuf
	xor	edi,edi
	.repeat
		push	edi
		invoke	RtlZeroMemory,offset sTempBuf,sizeof sTempBuf
		mov	ecx,[esi+edi*4]
		invoke	memcpy,addr sTempBuf,SaveListBuf,ecx
		add	SaveListBuf,ecx
		.if	SearchStyle==0		;match
			invoke	RtlZeroMemory,addr BufMatch,sizeof BufMatch
			invoke	GetWindowText,hMarch, ADDR BufMatch,sizeof BufMatch
			invoke	DoneMatch,addr sTempBuf,addr BufMatch
			.if	eax==1
				invoke	Add2Found,addr sTempBuf
			.endif
		.elseif SearchStyle==1		;Name	
			invoke	DoneName,addr sTempBuf,addr BufAdv1,addr BufAdv2
			.if	eax==1
				invoke	Add2Found,addr sTempBuf
			.endif
		.elseif SearchStyle==2		;Content	
			invoke	DoneContent,addr sTempBuf,addr BufAdv1,addr BufAdv2
			.if	eax==1
				invoke	Add2Found,addr sTempBuf
			.endif
		.elseif SearchStyle==3		;Content(disk)	
			invoke	DoneDisk,addr sTempBuf,DiskMemAddr,DiskFileLen
			.if	eax==1
				invoke	Add2Found,addr sTempBuf
			.endif
		.elseif SearchStyle==4		;Size	
			invoke	DoneSize,addr sTempBuf,cSizeA,cSizeB,cCmpStyle
			.if	eax==1
				invoke	Add2Found,addr sTempBuf
			.endif
		.elseif SearchStyle==5		;Date	
			invoke	DoneDate,addr sTempBuf,cDateA,cDateB,dDateStyle,cCmpStyle
			.if	eax==1
				invoke	Add2Found,addr sTempBuf
			.endif
		.elseif SearchStyle==6		;Time	
			invoke	DoneTime,addr sTempBuf,cTimeA,cTimeB,dDateStyle,cCmpStyle
			.if	eax==1
				invoke	Add2Found,addr sTempBuf
			.endif
		.endif

		invoke	Add2Check,addr sTempBuf
		invoke	WaitForSingleObject,hStopEvent,INFINITE
		pop	edi
		inc	edi
	.until	edi==TatalIndex

	invoke	HeapFree,hHeap,NULL,SaveLineLenBuf
	invoke	HeapFree,hHeap,NULL,SaveListBuf
	
	invoke	LeaveCriticalSection,ADDR stCS

	ret
AgainSearch endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
Resequence proc uses edi
	LOCAL   lvi:LV_ITEM

	invoke  SendMessage, hList, LVM_GETITEMCOUNT, 0, 0
        mov     edi, eax
        mov     lvi.imask, LVIF_PARAM
        mov     lvi.iSubItem, 0
        mov     lvi.iItem, 0
	.while (edi)
		m2m     lvi.lParam,lvi.iItem
		invoke  SendMessage, hList, LVM_SETITEM, 0, addr lvi
		inc     lvi.iItem
		dec     edi
	.endw
	ret
Resequence endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
AsciiBase proc uses  esi InPut:DWORD
	;invoke  AsciiBase, addr szBuff0

        xor	eax, eax
        mov     esi, InPut
        xor     ecx, ecx
        xor     edx, edx
        mov     al, [esi]
        inc     esi
	.while	al != 0
		sub	al, '0'          ; Convert to bcd
		lea     ecx, [ecx+ecx*4] ; ecx = ecx * 5
		lea     ecx, [eax+ecx*2] ; ecx = eax + old ecx * 10
		mov     al, [esi]
		inc     esi
	.endw
        lea     eax, [ecx+edx]     ; Move to eax
        ret

AsciiBase endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
ListViewSort proc uses edi lParam1:DWORD, lParam2, lParamSort
	;INVOKE     SendMessage, hList, LVM_SORTITEMS, 1, addr ListViewSort
	LOCAL   lvi:LV_ITEM
	LOCAL   Dir1:DWORD, Dir2
	LOCAL   szBuff0[256]:BYTE, szBuff1[256], Work[256]

        and     Dir1, 0
        and     Dir2, 0
        mov     lvi.imask, LVIF_TEXT
        lea     eax, szBuff0
        mov     lvi.pszText, eax
        mov     lvi.cchTextMax, 256
             
        mov     lvi.iSubItem, 1
	invoke  SendMessage, hList, LVM_GETITEMTEXT, lParam1, addr lvi
        xor     eax, eax
        mov     al, byte ptr szBuff0
        mov     Dir1, eax
	invoke  SendMessage, hList, LVM_GETITEMTEXT, lParam2, addr lvi
        xor     eax, eax
        mov     al, byte ptr szBuff0
        mov     Dir2, eax

	.if lParamSort == 1 || lParamSort == 2	;name
		mov     lvi.iSubItem, 1
		invoke  SendMessage, hList, LVM_GETITEMTEXT, lParam1, addr lvi
		invoke  lstrcpy, addr szBuff1, addr szBuff0
		invoke  SendMessage, hList, LVM_GETITEMTEXT, lParam2, addr lvi
		.if lParamSort == 1
			invoke	lstrcmpi, addr szBuff1, addr szBuff0
		.else	        
			invoke  lstrcmpi, addr szBuff0, addr szBuff1
		.endif
	.elseif lParamSort == 3 || lParamSort == 4	;size
		mov     lvi.iSubItem, 2
		invoke  SendMessage, hList, LVM_GETITEMTEXT, lParam1, addr lvi
		invoke  AsciiBase, addr szBuff0
		mov     edi, eax
		invoke  SendMessage, hList, LVM_GETITEMTEXT, lParam2, addr lvi
		invoke  AsciiBase, addr szBuff0
		.if lParamSort == 3
			sub	edi, eax
			mov     eax, edi
		.else
			sub     eax, edi
		.endif
	.elseif lParamSort == 5 || lParamSort == 6	;date
		mov     lvi.iSubItem, 2
		invoke  SendMessage, hList, LVM_GETITEMTEXT, lParam1, addr lvi

		;---------- [Rearrange the date fields] ----------
		invoke  lstrcpy, addr Work, addr szBuff0+6
		invoke  lstrcpyn, addr Work+4, addr szBuff0, 6
		invoke  lstrcpyn, addr Work+9, addr szBuff0+11, 9
		invoke  lstrcpy, addr szBuff0, addr Work
		invoke  lstrcpy, addr szBuff1, addr szBuff0
		invoke  SendMessage, hList, LVM_GETITEMTEXT, lParam2, addr lvi
		invoke  lstrcpy, addr Work, addr szBuff0+6
		invoke  lstrcpyn, addr Work+4, addr szBuff0, 6
		invoke  lstrcpyn, addr Work+9, addr szBuff0+11, 9
		invoke  lstrcpy, addr szBuff0, addr Work
		.if lParamSort == 5
			invoke  lstrcmpi, addr szBuff1, addr szBuff0
		.else	       
			invoke  lstrcmpi, addr szBuff0, addr szBuff1
		.endif
	.endif

	;---------- [Keep the folders on top] ----------
	.if byte ptr Dir1 == '<' && byte ptr Dir2 != '<'
		xor     eax, eax
		dec     eax
		ret
	.elseif byte ptr Dir2 == '<' && byte ptr Dir1 != '<'
		xor     eax, eax
		inc     eax
		ret
	.elseif byte ptr Dir1 == '<' && byte ptr Dir2 == '<'
		xor     eax, eax
		ret
	.endif
        ret

ListViewSort endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
MainDlg proc uses ebx ecx edx esi edi hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	local buffer[MAX_PATH]:BYTE
	local rect:RECT
	local sei:SHELLEXECUTEINFO
	local rt:RECT
	local x:DWORD
	local w:DWORD
	local h:DWORD
	local hE:DWORD
	
	.if uMsg == WM_CREATE
		m2m	hMain,hWnd
;//-------------------------------------------------------------------
		invoke	GetSystemDirectory, addr buffer, MAX_PATH
		invoke	lstrcat, addr buffer, S("\\shell32.dll")
		invoke	LoadLibrary, addr buffer
		mov	hinstShellLib, eax
		invoke	CreateWindowEx,0,S("SysAnimate32"),0,\
			ACS_CENTER+ACS_TRANSPARENT+WS_CHILD+WS_VISIBLE,\
			0,0,18,18,hWnd, ID_ANIMATE, hInstance, NULL
		mov	hwndAnim, eax
		invoke	GetClientRect, hwndAnim, addr rect
		mov	ebx,rect.left
		add	ebx,372
		mov	ecx,rect.top
		add	ecx,36
		mov	edx,rect.right
		mov	esi,rect.bottom
		invoke	SetWindowPos,hwndAnim,0,ebx,ecx,edx,esi,SWP_NOZORDER + SWP_DRAWFRAME
		invoke	SendMessage,hwndAnim, ACM_OPEN, hinstShellLib,152
;//-------------------------------------------------------------------
 		invoke	LoadIcon,hInstance, ICO_ICON
		invoke	SendMessage, hWnd, WM_SETICON, ICON_SMALL or ICON_BIG, eax
 		
		invoke	cStaticLtext,hWnd,S('SearchDir:'),2,8,160,18,-1
		invoke	cInEditText,hWnd,55,6,330,20,ID_DIR
		mov	hDir, eax		    	
		
		invoke	cStaticLtext,hWnd,S('Match:'),19,37,60,18,-1
		invoke	cInEditText,hWnd,55,35,330,20,ID_MATCH
		mov	hMarch, eax
		invoke	cAutoCheck,hWnd,S('Case'),340,32,50,14,ID_CHK0
		mov	hChk0, eax
		
		invoke	cGroupButton,hWnd,S('Filtered'),2,58,413,135,-1
		mov	hListStaic,eax	
		invoke	cListView,hWnd,6,73,404,108,ID_LIST
		mov	hList, eax

		invoke	cGroupButton,hWnd,S('Checking'),2,196,413,137,-1
		mov	hEditStaic,eax	
		invoke	cEditView,hWnd,6,200,404,123,ID_EDIT
		mov	hEdit, eax
		
		invoke	cButton,hWnd,S('...'),392,7,22,17,ID_OPEN
 		mov	hBtnOpen, eax
		
		invoke	cButton,hWnd,S('S&top'),2,337,50,20,ID_STOP
		mov	hBtnStop, eax
		invoke	cButton,hWnd,S('&Start'),57,337,50,20,ID_START
		mov	hBtnStart, eax
		invoke	cButton,hWnd,S('Clear&F'),112,337,50,20,ID_CLEARF
		mov	hBtnClearF, eax
		invoke	cButton,hWnd,S('Clear&C'),167,337,50,20,ID_CLEARC
		mov	hBtnClearC, eax
		invoke	cButton,hWnd,S('&Help'),365,337,50,20,ID_HELP
		mov	hBtnHelp, eax
		invoke	cButton,hWnd,S('&Advanced'),312,337,60,20,ID_ADVANCE
		mov	hBtnConfig, eax
		
		invoke	CreateEvent,NULL,TRUE,FALSE,NULL
		mov	hStopEvent,eax
		
		invoke	InitializeCriticalSection,ADDR stCS 
		;function initializes a critical section object
		
		invoke	InitListView
		
		invoke	RtlZeroMemory, offset Shellpath, sizeof Shellpath
		invoke	szCopy,offset Shellpath,S("c:\windows\system32\notepad.exe") ;default shellexec		
		
	.elseif uMsg==WM_COMMAND
		mov	eax,wParam
		.if eax==ID_START
			invoke	SetEvent,hStopEvent
;--------------------------------------------------
			invoke	SetTimer,hWnd,ID_TIMER,1000,NULL  ; for stop hwndAnim
			invoke	SendMessage, hwndAnim, ACM_PLAY,65535,0FFFF0000H
;--------------------------------------------------
			.if	FoundLineIndex !=0 && SearchFlag==TRUE
				mov	ebx,FoundLineIndex
				invoke	CreateThread, 0, 0, offset AgainSearch, ebx, 0, 0
			.else
				invoke	SendMessage, hList, LVM_DELETEALLITEMS, 0h, 0h
				mov	FoundLineIndex,0
				invoke	SetWindowText,hBtnStart,S("&Start")
				
				invoke	RtlZeroMemory,addr BufEdit,sizeof BufEdit
				invoke	SetDlgItemText,hWnd,ID_EDIT,addr BufEdit
				mov	CheckLineIndex,0
				mov	lineNum,0
				
				.if	SearchStyle==0		;match
					invoke	RtlZeroMemory,addr BufMatch,sizeof BufMatch
					invoke	GetWindowText,hMarch, ADDR BufMatch,sizeof BufMatch
				.endif
				invoke	NewSearch
			.endif
		.elseif eax==ID_STOP
			invoke	ResetEvent,hStopEvent
		.elseif eax==ID_CLEARF
			invoke	SendMessage, hList, LVM_DELETEALLITEMS, 0h, 0h
			mov	FoundLineIndex,0
			invoke	SetWindowText,hBtnStart,S("&Start")
		.elseif eax==ID_CLEARC
			invoke	RtlZeroMemory,addr BufEdit,sizeof BufEdit
			invoke	SetDlgItemText,hWnd,ID_EDIT,addr BufEdit
			mov	CheckLineIndex,0
			mov	lineNum,0
		.elseif eax==ID_OPEN
			invoke	RtlZeroMemory,addr BufTemp,sizeof BufTemp
			invoke	GetPathFromDLG,hWnd
			invoke	lstrcat,ADDR BufTemp,eax
			invoke	SetDlgItemText,hWnd,ID_DIR, ADDR BufTemp
		.elseif eax==ID_ADVANCE
			invoke	DialogBoxParam,hInstance,IDC_CHILD,hWnd,offset AdvanceDlg,0
		.elseif eax==ID_HELP
			invoke	MessageBox,NULL,addr szHelp,S("Help"),MB_OK + MB_ICONINFORMATION
		.endif
	.elseif uMsg== WM_TIMER
		
		push	edi
		lea	edi,CheckIndexbuf
		mov	eax,[edi+4]
		mov	[edi],eax
		mov	eax,CheckLineIndex
		mov	[edi+4],eax
		mov	eax,[edi]
		mov	ebx,[edi+4]
		.if	ebx == eax	;delta CheckLineIndex =0
			invoke	SendMessage, hwndAnim, ACM_STOP, 0, 0
			invoke	KillTimer,hWnd,ID_TIMER
			invoke	SetWindowText,hBtnStart,S("&Start(R)")
			.if	SearchStyle==3
				invoke	CloseHandle,hFileDisk
				invoke	HeapFree,hHeap,NULL,DiskMemAddr
			.endif
		.endif
		pop	edi

	.elseif uMsg==WM_NOTIFY					; listview feedback
		
		push	edi
		mov	edi,lParam
		assume	edi:ptr NMHDR
		mov	eax,[edi].hwndFrom
		.if	eax==hList					; is it the listview?
			.if [edi].code==NM_DBLCLK		; was item double-clicked?
				mov	sei.cbSize,sizeof SHELLEXECUTEINFO
				mov	sei.fMask,SEE_MASK_NOCLOSEPROCESS
				m2m	sei.hwnd,hWnd
				mov	sei.lpVerb,NULL
				mov	sei.lpFile,offset Shellpath 
				invoke	GetRowCurrentFocus,1
				mov	sei.lpParameters ,eax   
				mov	sei.lpDirectory,NULL	
				mov	sei.nShow,SW_SHOWNORMAL	
				m2m	sei.hInstApp,hInstance
				invoke	ShellExecuteEx,ADDR sei
				;invoke	ShellExecute,hWnd,0,offset Shellpath,esi,0,SW_SHOW
			.elseif [edi].code==LVN_COLUMNCLICK
				.if [edi.NM_LISTVIEW].iSubItem == 1
					.if !SortN	;name
						invoke	SendMessage, hList, LVM_SORTITEMS, 1, addr ListViewSort
						invoke  Resequence
						or	SortN, 1
					.else
						invoke  SendMessage, hList, LVM_SORTITEMS, 2, addr ListViewSort
						invoke  Resequence
						and     SortN, 0
					.endif                        
				.elseif [edi.NM_LISTVIEW].iSubItem == 2
					.if	SearchStyle==4
						.if !SortS	;size
							invoke	SendMessage, hList, LVM_SORTITEMS, 3, addr ListViewSort
							invoke  Resequence
							or	SortS, 1
						.else
							invoke  SendMessage, hList, LVM_SORTITEMS, 4, addr ListViewSort
							invoke  Resequence
							and     SortS, 0
						.endif
					.elseif	SearchStyle==5 || SearchStyle==6
						.if !SortD	;date
							invoke	SendMessage, hList, LVM_SORTITEMS, 5, addr ListViewSort
							invoke  Resequence
							or	SortD, 1
						.else
							invoke	SendMessage, hList, LVM_SORTITEMS, 6, addr ListViewSort
							invoke  Resequence
							and     SortD, 0
						.endif
					.endif
				.endif
			.endif
		.endif
		assume	edi:nothing
		pop	edi

	.elseif uMsg == WM_SIZE

		invoke	GetClientRect, hWnd, addr rt
		mov	ebx,rt.right
		sub	ebx,rt.left
		sub	ebx,84
		push	ebx
		invoke	MoveWindow, hDir,55,6, ebx, 20, TRUE
		pop	ebx
		sub	ebx,43
		invoke	MoveWindow, hMarch,55,35, ebx, 20, TRUE

		mov	esi,rt.right
		sub	esi,24
		invoke	MoveWindow, hBtnOpen, esi, 7, 22,17, TRUE
		invoke	MoveWindow, hwndAnim, esi, 36, 22,17, TRUE
		sub	esi,43
		invoke	MoveWindow, hChk0,esi,39,45,12, TRUE
		
		mov	esi,rt.right
		sub	esi,52
		mov	edi,rt.bottom
		sub	edi,21
		invoke	MoveWindow, hBtnStop, 2,edi,50,20, TRUE
		invoke	MoveWindow, hBtnStart,57,edi,50,20, TRUE
		invoke	MoveWindow, hBtnClearF,112,edi,50,20, TRUE
		invoke	MoveWindow, hBtnClearC,167,edi,50,20, TRUE
		invoke	MoveWindow, hBtnHelp, esi, edi, 50,20, TRUE
		sub	esi,65
		invoke	MoveWindow, hBtnConfig, esi, edi, 60,20, TRUE

		invoke	GetClientRect, hWnd, addr rt
		mov	esi,rt.left
		add	esi,6
		mov	x,esi
		
		mov	esi,rt.right
		sub	esi,rt.left
		sub	esi,12
		mov	w,esi
		
		mov	esi,rt.bottom
		sub	esi,rt.top
		sub	esi,240
		mov	h,esi
		
		mov	edi,rt.top
		add	edi,70
		invoke	MoveWindow, hList,x, edi,w,h, TRUE
		
		mov	ebx,x
		sub	ebx,4
		
		sub	edi,12

		mov	ecx,w
		add	ecx,8
		
		mov	edx,h
		add	edx,16
		
		invoke	MoveWindow, hListStaic,ebx, edi,ecx,edx, TRUE
		
		add	edi,h
		add	edi,30
		
		mov	esi,rt.bottom
		sub	esi,edi
		sub	esi,32
		mov	hE,esi
		invoke	MoveWindow, hEdit,x, edi,w,hE, TRUE
		
		mov	ebx,x
		sub	ebx,4
		
		sub	edi,13

		mov	ecx,w
		add	ecx,8
		
		mov	edx,hE
		add	edx,18
		
		invoke	MoveWindow, hEditStaic,ebx, edi,ecx,edx, TRUE

	.elseif uMsg == WM_CLOSE
		invoke	KillTimer,hWnd,ID_TIMER 
		invoke	DeleteCriticalSection,ADDR stCS
		invoke	DestroyWindow, hWnd

	.elseif uMsg == WM_DESTROY
		
		invoke SendMessage, hwndAnim, ACM_OPEN, 0, NULL
		invoke DestroyWindow, hwndAnim
		invoke FreeLibrary, hinstShellLib
		
		invoke PostQuitMessage, NULL

	.else
		invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		ret
	.endif
         xor    eax, eax
         ret
MainDlg endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
TopXY proc wDim:DWORD, sDim:DWORD

	shr sDim, 1      
	shr wDim, 1      
	mov eax, wDim    
	sub sDim, eax    

	mov eax, sDim
	ret

TopXY endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
WinMain proc hInst:DWORD, hPrevInst, CmdLine, CmdShow
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL Wwd:DWORD
	LOCAL Wht:DWORD
	LOCAL Wtx:DWORD
	LOCAL Wty:DWORD

        mov	wc.cbSize, sizeof WNDCLASSEX
        mov	wc.style, CS_BYTEALIGNCLIENT or CS_BYTEALIGNWINDOW
        mov	wc.lpfnWndProc, offset MainDlg
        mov	wc.cbClsExtra, NULL
        mov	wc.cbWndExtra, NULL
        m2m	wc.hInstance,hInst
        mov	wc.hbrBackground, COLOR_BTNFACE+1
        mov	wc.lpszClassName, S("FindFile")
	invoke	LoadIcon, NULL, IDI_APPLICATION
        mov	wc.hIcon, eax
        mov	wc.hIconSm, eax
	invoke	LoadCursor, NULL, IDC_ARROW
        mov	wc.hCursor, eax

	invoke	RegisterClassEx, addr wc
	mov	Wwd, 425
	mov	Wht, 385

	invoke	GetSystemMetrics,SM_CXSCREEN
	invoke	TopXY,Wwd,eax
	mov	Wtx, eax

	invoke	GetSystemMetrics,SM_CYSCREEN
	invoke	TopXY,Wht,eax
	mov	Wty, eax

	invoke	CreateWindowEx, NULL, S("FindFile"),\
			S("SearchFile"), WS_OVERLAPPEDWINDOW,\
			Wtx,Wty,Wwd,Wht,NULL, NULL, hInst, NULL
        mov	hMain, eax

	invoke	ShowWindow, hMain, SW_SHOWNORMAL
	invoke	UpdateWindow, hMain

	.while TRUE
		invoke GetMessage, addr msg, NULL, 0, 0
		.break .if (!eax)
		invoke TranslateMessage, addr msg
		invoke DispatchMessage, addr msg
	.endw
        mov eax, msg.wParam
        ret
WinMain endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
start:
	invoke	GetProcessHeap
	mov	hHeap, eax
	
	invoke	HeapAlloc,hHeap,HEAP_ZERO_MEMORY, 1024d
	mov	ListBuf,eax
        
	invoke	GetModuleHandle,NULL
        mov	hInstance,eax

	invoke	GetCommandLine
 	invoke	WinMain, hInstance ,NULL, eax, SW_SHOWDEFAULT
        invoke	ExitProcess,eax
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

end start

;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>